<?php
namespace Fiscal\Repositories;

class Notafiscal extends \Doctrine\ORM\EntityRepository
{
    const ENTRADA = 'E';
    const STATUS_S = 'S';
    const ENTRADA_SAIDA = 'S';
    const STATUS_NF = 'P';

    public function getNotafiscal() {
        $dql = "
        SELECT nf.*
          FROM \Fiscal\Entities\Base\Notafiscal nf
          WHERE
        ";
    }

    /**
     * Verifica alguma entrada sem nota fiscal.
     *
     * @param $nrorg
     * @param $filial
     * @param $dtproces
     *
     * @return mixed
     */
    public function verificaEntradaSemNotas($nrorg, $filial, $dtproces){
        $sql = 'SELECT T.CDFILIAL, T.NRLANCTONF
                  FROM NOTAFISCAL T
                 WHERE T.CDFILIRECE = :P_CDFILIAL
                   AND T.IDENTRSAIDOP = :P_ENTRADA
                   AND T.CDTIPOOPER   = :P_TIPOOPER_1
                   AND T.DTENTRSAID = :P_DTPROCESSA
                 MINUS
                SELECT IT.CDFILIALIT, IT.NRLANCTONFIT
                  FROM ITEMNOTAFISC IT, NOTAFISCAL T
                 WHERE T.CDFILIRECE   = :P_CDFILIAL
                   AND T.IDENTRSAIDOP = :P_ENTRADA
                   AND T.CDTIPOOPER   = :P_TIPOOPER_2
                   AND T.DTENTRSAID = :P_DTPROCESSA
                   AND T.CDFILIAL   = IT.CDFILIAL
                   AND T.NRLANCTONF = IT.NRLANCTONF';

        $params = array(
            'P_NRORG' => $nrorg,
            'P_CDFILIAL' => $filial,
            'P_TIPOOPER_1' => '10',
            'P_TIPOOPER_2' => '11',
            'P_DTPROCESSA' => $dtproces,
            'P_ENTRADA' => self::ENTRADA,
        );
        try{
            return self::getEntityManager()->getConnection()->fetchColumn($sql, $params);
        } catch(\Exception $e) {
            throw $e;
        }
        /*$entity_manager = $this->getEntityManager();
        $result_set_mapping = new \Doctrine\ORM\Query\ResultSetMappingBuilder($entity_manager);
        $result_set_mapping->addRootEntityFromClassMetadata('\Fiscal\Entities\Notafiscal', "T");
        $result = $entity_manager->createNativeQuery($sql, $result_set_mapping)->execute($params);

        return count($result) > 0 ? $result : false;*/
    }

    public function getDadosEmalNfe($cdfiliemit, $nrlanctonf){

        $sql = <<<SQL
                      SELECT N.NRORG, N.CDFILIAL, N.NRLANCTONF, N.NRNOTAFISCALELE, N.NRACESSONFE, D.DSARQXMLNFE AS DSXMLNFE, A.DSARQXMLNFE AS DSXMLRECIBONFE,
                   F.CDFILIAL AS CDFILIALORIG, E.NMEMPRESA AS NMRAZSOCORIG, NVL(EF.DSLOGINSMTP, NVL(EF.DSEMAILEMXMLNFE, EF.DSEMAILFILI)) AS DSEMAILORIG,
                   NVL(EF.DSLOGINSMTP, NVL(EF.DSEMAILEMXMLNFE, EF.DSEMAILFILI)) AS DSLOGINSMTPORIG, EF.CDSENHEMAILF AS CDSENHEMAILORIG, EF.DSSMTPEMAILF AS DSSMTPEMAILORIG,
                   N.IDORIGDESTNF, ED.CDDESTNFE, ED.NMRAZSOCDEST, ED.DSEMAILDEST, ED.COMPACTAR, E.DSMENSEMAILNFE,
                   N.IDTPIJURTRAN, N.NRINSJURTRAN, NVL(TP.DSEMAILTRANSPNFE,TP.DSEMAILTRAN) DSEMAILTRANSPNFE, NVL(TP.IDCOMPARQXMLTRA, 'S') IDCOMPARQXMLTRA,
                   N.CDEMPRESA, N.CDINSCESTA, N.CDINSCMUNI, NVL(N.CDSERIE, N.CDSERIEENTR) AS CDSERIE, EF.IDUTSSLEMAIL, EF.IDUTTLSEMAIL, C.DSARQXMLNFE AS DSXMLCANCNFE,
                   E.DSMENSEMAILCANC
              FROM NOTAFISCAL N, ARQXMLNFE D, ARQXMLNFE A, ARQXMLNFE C, ENDEFILI EF, FILIAL F, EMPRESA E,
                   TRANSPORT TP,
                   (SELECT C.NRORG AS NRORG, C.CDCLIENTE AS CDDESTNFE, C.NMRAZSOCCLIE AS NMRAZSOCDEST, EC.DSEMAILCLIENFE AS DSEMAILDEST, C.IDCOMPARQXMLCLI AS COMPACTAR, 'C' AS IDENTIFICADOR
                      FROM CLIENTE C, ENDECLIE EC
                     WHERE C.CDCLIENTE = EC.CDCLIENTE(+)
                       AND 'P' = EC.IDTPENDECLIE(+)
                       AND C.NRORG    = EC.NRORG(+)
                     UNION
                    SELECT F.NRORG AS NRORG, F.CDFORNECED AS CDDESTNFE, F.NMRAZSOCFORN AS NMRAZSOCDEST, EF.DSEMAILFORNNFE AS DSEMAILDEST, F.IDCOMPARQXMLFOR AS COMPACTAR, 'F' AS IDENTIFICADOR
                      FROM FORNECEDOR F, ENDEFORN EF
                     WHERE F.CDFORNECED = EF.CDFORNECED(+)
                       AND 'P' = EF.IDTPENDEFORN(+)
                       AND F.NRORG      = EF.NRORG(+)
                     UNION
                    SELECT FL.NRORG AS NRORG, FL.CDFILIAL AS CDDESTNFE, FL.NMFILIAL AS NMRAZSOCDEST, EFL.DSEMAILEMXMLNFE AS DSEMAILDEST, FL.IDCOMPARQXMLFIL AS COMPACTAR, 'L' AS IDENTIFICADOR
                      FROM FILIAL FL, ENDEFILI EFL
                     WHERE FL.CDFILIAL = EFL.CDFILIAL(+)
                       AND 'P' = EFL.IDTPENDEFILI(+)
                       AND FL.NRORG     = EFL.NRORG(+)) ED
             WHERE N.CDFILIAL = :P_CDFILIAL
               AND N.NRLANCTONF = :P_NRLANCTONF
               AND N.NRORG = :P_NRORG
               AND N.CDEMPRESA = E.CDEMPRESA(+)
               AND N.NRORG     = E.NRORG(+)
               AND N.CDFILIAL = D.CDFILIAL(+)
               AND N.NRLANCTONF = D.NRLANCTONF(+)
               AND 'D' = D.IDTIPOARQXML(+)
               AND N.NRORG    = D.NRORG(+)
               AND N.CDFILIAL = A.CDFILIAL(+)
               AND N.NRLANCTONF = A.NRLANCTONF(+)
               AND 'A' = A.IDTIPOARQXML(+)
               AND N.NRORG    = A.NRORG(+)
               AND N.CDFILIAL = C.CDFILIAL(+)
               AND N.NRLANCTONF = C.NRLANCTONF(+)
               AND 'C' = C.IDTIPOARQXML(+)
               AND N.NRORG     = C.NRORG(+)
               AND N.IDTPIJURTRAN = TP.IDTPIJURTRAN(+)
               AND N.NRINSJURTRAN = TP.NRINSJURTRAN(+)
               AND N.NRORG        = TP.NRORG(+)
               AND DECODE(N.IDENTRSAIDOP, 'S', N.CDFILIEMIT, N.CDFILIRECE) = F.CDFILIAL
               AND N.NRORG        = F.NRORG(+)
               AND F.CDFILIAL = EF.CDFILIAL(+)
               AND 'P' = EF.IDTPENDEFILI(+)
               AND F.NRORG    = EF.NRORG(+)
               AND N.IDORIGDESTNF = ED.IDENTIFICADOR(+)
               AND N.NRORG        = ED.NRORG(+)
               AND DECODE(N.IDORIGDESTNF, 'C', N.CDCLIENTE,
                                          'F', N.CDFORNECED,
                                           DECODE(N.IDENTRSAIDOP, 'S', N.CDFILIRECE, N.CDFILIEMIT)) = ED.CDDESTNFE(+)

SQL;

        $params = array(
            "P_CDFILIAL"   => $cdfiliemit,
            "P_NRLANCTONF" => $nrlanctonf,
            "P_NRORG" =>\Ambiente::getNrorg(),

        );

        return \Setforms2\Shared\Connection::getInstance()->fetchAll($sql, $params);

    }


    /**
     * Verifica NF de saída não emitidas
     *
     * @param unknown $filial
     * @param $dtprocessa
     * @internal param \Fiscal\Repositories\unknown $nrorg
     * @internal param \Fiscal\Repositories\unknown $dtproces
     * @return Ambigous <boolean, unknown>
     */
    public function verificaNFSaida($filial, $dtprocessa){
        $sql = 'SELECT CDFILIAL, NRLANCTONF
				FROM NOTAFISCAL NF
				WHERE 	NF.CDFILIEMIT   = :P_CDFILIAL    AND
      					NF.DTENTRSAID   = :P_DTPROCESSA  AND
      					NF.IDENTRSAIDOP = :P_ENTRADA_SAIDA AND
      					NF.IDSTATUS     = :P_STATUS_NF';

        $params = array(
            'P_CDFILIAL' => $filial,
            'P_DTPROCESSA' => $dtprocessa,
            'P_ENTRADA_SAIDA' => self::ENTRADA_SAIDA,
            'P_STATUS_NF' => self::STATUS_NF
        );

        try{
            return self::getEntityManager()->getConnection()->fetchColumn($sql, $params);
        } catch(\Exception $e) {
            throw $e;
        }

        /*$entity_manager = $this->getEntityManager();
        $result_set_mapping = new \Doctrine\ORM\Query\ResultSetMappingBuilder($entity_manager);
        $result_set_mapping->addRootEntityFromClassMetadata('\Fiscal\Entities\Notafiscal', "T");
        $result = $entity_manager->createNativeQuery($sql, $result_set_mapping)->execute($params);

        return count($result) > 0 ? $result : false;*/
    }

    /**
     *  Consulta notas fiscais de uma empresa por um determinado tipo de operador.
     *
     * @param $objEmpresa
     * @param $primeiroDiaMesDtProc
     * @param $ultimoDiaMesDtProc
     * @param $nrorg
     *
     * @return array
     */
    public function consultaNotasPorTipoOperador($objEmpresa, $primeiroDiaMesDtProc, $ultimoDiaMesDtProc, $nrorg){
        $sql = "SELECT N.*
                  FROM NOTAFISCAL N,
                      (SELECT CDTIPOOPER,
                              IDENTRSAIDOP,
                              NRORG
                         FROM TIPOOPERAC
                        WHERE IDUTRECEITA = :P_STATUS_S
                          AND IDENTRSAIDOP  = :P_STATUS_S
                      ) T
                WHERE N.CDEMPRESA    = :P_CDEMPRESA
                  AND N.NRORG        = :P_NRORG
                  AND N.NRORG        = T.NRORG
                  AND N.CDTIPOOPER   = T.CDTIPOOPER
                  AND N.IDENTRSAIDOP = T.IDENTRSAIDOP
                  AND N.DTENTRSAID BETWEEN :P_PRIMEIRODIA AND :P_ULTIMODIA
                  AND N.IDSTATUS IN ('E','A')";

        $params = array(
            "P_CDEMPRESA" => $objEmpresa,
            "P_PRIMEIRODIA" => $primeiroDiaMesDtProc,
            "P_ULTIMODIA" => $ultimoDiaMesDtProc,
            "P_STATUS_S" => self::STATUS_S,
            "P_NRORG" => $nrorg,
        );

        $entityManager = $this->getEntityManager();
        $resultSetMapping = new \Doctrine\ORM\Query\ResultSetMappingBuilder($entityManager);
        $resultSetMapping->addRootEntityFromClassMetadata('Fiscal\Entities\Notafiscal', "N");

        $result = $entityManager->createNativeQuery($sql, $resultSetMapping)->execute($params);
        return is_array($result) ? $result : false;
    }


    public function consultaNotasFiscaisEntrada($filial, $nrorg, $dtEntrada){
        $sql = "SELECT N.*
                  FROM NOTAFISCAL N, TIPOOPERAC T
                 WHERE N.CDFILIRECE = :P_CDFILIAL
                   AND N.NRORG = :P_NRORG
                   AND N.DTENTRSAID = :P_DTENTRSAID
                   AND N.IDENTRSAIDOP = 'E'
                   AND N.IDSTATUS <> 'C'
                   AND N.IDSISTEMA IN ('DFE','EST') OR N.IDSISTEMA IS NULL
                   AND N.CDTIPOOPER NOT IN ('09','10')
                   AND N.NRORG = T.NRORG
                   AND N.IDENTRSAIDOP = T.IDENTRSAIDOP
                   AND N.CDTIPOOPER = T.CDTIPOOPER
                   AND NVL(T.IDCOMPEMISRE, 'F') = 'F'
                   AND NRSEQCAPADOC IS NULL";

        $params = array(
            "P_CDFILIAL"   => $filial,
            "P_NRORG"      => $nrorg,
            "P_DTENTRSAID" => $dtEntrada,
        );

        $entityManager = $this->getEntityManager();
        $resultSetMapping = new \Doctrine\ORM\Query\ResultSetMappingBuilder($entityManager);
        $resultSetMapping->addRootEntityFromClassMetadata('Fiscal\Entities\Notafiscal', "N");

        $result = $entityManager->createNativeQuery($sql, $resultSetMapping)->execute($params);
        return count($result) > 0 ? $result : false;
    }

    public function consultaNotasFiscaisSaida($filial, $nrorg, $dtSaida){
        $sql = "SELECT N.*
                  FROM NOTAFISCAL N, TIPOOPERAC T
                 WHERE N.CDFILIEMIT = :P_CDFILIAL
                   AND N.DTENTRSAID = :P_DTENTRSAID
                   AND N.IDENTRSAIDOP = 'S'
                   AND N.IDSTATUS <> 'C'
                   AND (N.IDGEROUTDOCU IS NULL) OR (N.IDGEROUTDOCU = 'A')
                   AND N.IDSISTEMA IN ('DFS','FAI','FAS','FAC') OR N.IDSISTEMA IS NULL
                   AND N.IDENTRSAIDOP = T.IDENTRSAIDOP
                   AND N.CDTIPOOPER   = T.CDTIPOOPER
                   AND NVL(T.IDCOMPEMISRE, 'F') = 'F'
                   AND NRSEQCAPADOC IS NULL";

        $params = array(
            "P_CDFILIAL" => $filial,
            "P_NRORG" => $nrorg,
            "P_DTENTRSAID" => $dtSaida,
        );

        $entityManager = $this->getEntityManager();
        $resultSetMapping = new \Doctrine\ORM\Query\ResultSetMappingBuilder($entityManager);
        $resultSetMapping->addRootEntityFromClassMetadata('Fiscal\Entities\Notafiscal', "N");

        $result = $entityManager->createNativeQuery($sql, $resultSetMapping)->execute($params);
        return count($result) > 0 ? $result : false;
    }

    public function consultaCorpoNFFornecedor($cdfilial, $nrlanctonf, $nrorg)
    {
        try{
            $sql = <<<SQL
    SELECT N.NRORG,N.CDFILIAL, F.NMFILIAL, N.NRLANCTONF, N.CDEMPRESA, E.CDCNAE, I.NMREPRINSEST,
           E.NMRAZSOCEMPR AS  NMRAZSOCEMIT, I.NRINSJURIEST AS NRINSJUREMIT, I.IDTPIJURIEST AS IDTPIJUREMIT, (I.SGESTADO) AS SGESTAEMIT, (ESE.CDESTADOIBGE) AS CDESTAIBGEEMIT,
           (MI.NMMUNICIPIO) AS NMMUNIEMIT, (MI.CDMUNICIBGE) AS CDMUNIIBGEEMIT, I.DSENDEIEST AS DSENDEEMIT,
           I.NMBAIRIEST AS NMBAIREMIT, I.NRCEPIEST AS NRCEPEMIT, I.NRTELEIEST AS NRTELEEMIT, I.NRFAXIEST AS NRFAXEMIT, N.CDINSCESTA AS NRINSCESTEMIT,
           ' ' AS DSCOMPENDEMIT, PE.CDPAIS AS CDPAISEMIT, PE.CDPAISBACEN AS CDPAISBACENEMIT, PE.NMPAIS AS NMPAISEMIT,
           FO.NMRAZSOCFORN AS NMRAZSOCCLIE, N.IDTPIJURNF AS IDTPIJURCLIE, N.NRINSJURNF AS NRINSJURCLIE, (EF.SGESTADO) AS SGESTACLIE, ESC.CDESTADOIBGE AS CDESTAIBGECLIE,
           (MEC.NMMUNICIPIO) AS NMMUNICLIE, (MEC.CDMUNICIBGE) AS CDMUNIIBGECLIE,  EF.DSENDEFORN AS DSENDECLIE,
           EF.NMBAIRFORN AS NMBAIRCLIE, EF.NRCEPFORN AS NRCEPCLIE, EF.NRTELEFORN AS NRTELECLIE, EF.NRFAXFORN AS NRFAXCLIE, FO.NRINSESTFORN AS NRINSCESTCLIE,
           EF.DSCOMPENDFOR AS DSCOMPENDCLI, PC.CDPAIS AS CDPAISCLIE, PC.CDPAISBACEN AS CDPAISBACENCLIE,  PC.NMPAIS AS NMPAISCLIE,
           N.NRNOTAFISC, NVL(N.DTEMISSAO, N.DTENTRSAID) DTEMISSAO, N.DTENTRSAID,
           DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(VRPRODUTOS, 2), '9999999999999.99')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(VRPRODUTOS, 2), '9999999999999.99')), LTRIM(TO_CHAR(ROUND(VRPRODUTOS, 2), '9999999999999.99'))) AS VRPRODUTOS,
           DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(VRNOTAFISC, 2), '9999999999999.99')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(VRNOTAFISC, 2), '9999999999999.99')), LTRIM(TO_CHAR(ROUND(VRNOTAFISC, 2), '9999999999999.99'))) AS VRNOTAFISC,
           N.NRPLACAVEIC, N.SGUFVEIC, N.IDPGTOFRETE,
           N.DSQTDEVOLU, N.DSESPECVOLU, N.DSMARCAVOLU, N.DSNUMEVOLU,
           DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(VRPLIQUVOLU, 3), '999999999999.999')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(VRPLIQUVOLU, 3), '999999999999.999')), LTRIM(TO_CHAR(ROUND(VRPLIQUVOLU, 3), '999999999999.999'))) AS VRPLIQUVOLU,
           DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(VRPBRUTOVOLU, 3), '999999999999.999')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(VRPBRUTOVOLU, 3), '999999999999.999')), LTRIM(TO_CHAR(ROUND(VRPBRUTOVOLU, 3), '999999999999.999'))) AS VRPBRUTOVOLU,
           I.NRSERIECERTIFIC, NVL(N.IDORIGDESTNF , 'F') IDORIGDESTNF, '' AS CDCLIENTE, N.CDFORNECED, '' AS CDFILIRECE,
           N.IDENTRSAIDOP, N.CDTIPOOPER, N.NRACESSONFE,
           N.IDSTATUSNFE, N.NRNOTAFISCALELE,  N.NRLOTENFE,
           NVL(N.DSCFOPINFUSU, N.DSCDFISOPENF) AS NMTIPOOPER, O.IDOPERDEVONF, I.IDTPIMPRESDANFE,
           NVL(S.CDSERIENFE, SE.CDSERIEENTRNFE) AS CDSERIE,
           S.DSSERIE AS DSSERIE, N.NRINSJURTRAN,
           N.IDTPIJURTRAN, T.NMRAZSOCTRAN, T.NRINSESTTRAN,
           (T.SGESTADO) AS SGESTATRAN, (MT.NMMUNICIPIO) AS NMMUNITRAN,
           T.DSENDETRAN, NVL(N.CDCFOPINFUSU, N.CDFISOPENTF) AS CDFISOPENTF, NVL(N.DSCFOPINFUSU, N.DSCDFISOPENF) AS DSCDFISOPENF, N.CDINSCMUNI,
           N.CDMODDOCFISC, N.IDTIPOEMISNFE,
           FO.NRINSCSUFRAMAFO AS NRINSCSUFRAMA,
           FO.NMFANTFORN AS NMFANT, EM.CDESTADOIBGE AS CDESTADOIBGEEMP,
           ME.CDMUNICIBGE AS CDMUNICIBGEEMP,
           E.SGESTADO AS SGESTADOEMP, N.CDINSCESTAST, EF.DSEMAILFORNNFE AS DSEMAILDEST, DTHRPROTOCOLNFE,
           NRREGDPECNFE, DTHRREGCONTNFE, CDBARRACONTING, IDBRINDETPOPER,
           NVL(S.CDSERIENFESCAN, SE.CDSERIEENTSCAN) AS CDSERIESCAN, NVL(O.IDNFESTCANC, 'N') IDNFESTCANC, NVL(O.IDNFAJUSTE, 'N') IDNFAJUSTE,
           N.IDSTATUS
    FROM  NOTAFISCAL N, TRANSPORT T, FORNECEDOR FO,
          ENDEFORN EF, FILIAL F, INSCRESTAD I,
          MUNICIPIO MI, MUNICIPIO MT, MUNICIPIO MEC, MUNICIPIO ME,
          TIPOOPERAC O, EMPRESA E, SERIENF S,
          ESTADO ESE, ESTADO ESC, ESTADO EM,
          PAIS PE, PAIS PC, SERIEENTR SE
    WHERE (N.CDFILIEMIT = :CDFILIAL) AND
          (N.NRLANCTONF = :NRLANCTONF) AND
          (N.NRORG = :NRORG) AND
          (N.IDORIGDESTNF = 'F') AND
          (N.IDTPIJURTRAN = T.IDTPIJURTRAN(+)) AND
          (N.NRINSJURTRAN = T.NRINSJURTRAN(+)) AND
          (N.NRORG        = T.NRORG(+))        AND
          (N.CDFORNECED = FO.CDFORNECED(+)) AND
          (N.NRORG      = FO.NRORG(+))      AND
          (FO.CDFORNECED = EF.CDFORNECED(+)) AND
          (FO.NRORG      = EF.NRORG(+))      AND
          (EF.IDTPENDEFORN = NVL(FO.IDENDEMISFOR,'P')) AND
          (N.CDFILIAL = F.CDFILIAL) AND
          (N.NRORG    = F.NRORG)    AND
          (N.CDEMPRESA = E.CDEMPRESA) AND
          (N.NRORG     = E.NRORG)     AND
          (I.CDEMPRESA = E.CDEMPRESA) AND
          (I.NRORG     = E.NRORG)     AND
          (N.CDINSCESTA = I.CDINSCESTA) AND
          (N.NRORG      = I.NRORG)      AND
          (E.CDPAIS = EM.CDPAIS(+)) AND
          (E.SGESTADO = EM.SGESTADO(+)) AND
          (E.CDPAIS = ME.CDPAIS(+)) AND
          (E.SGESTADO = ME.SGESTADO(+)) AND
          (E.CDMUNICIPIO = ME.CDMUNICIPIO(+)) AND
          (I.CDPAIS = PE.CDPAIS) AND
          (I.CDPAIS = ESE.CDPAIS(+)) AND
          (I.SGESTADO = ESE.SGESTADO(+)) AND
          (I.CDPAIS = MI.CDPAIS(+)) AND
          (I.SGESTADO = MI.SGESTADO(+)) AND
          (I.CDMUNICIPIO = MI.CDMUNICIPIO(+)) AND
          (EF.CDPAIS = PC.CDPAIS(+)) AND
          (EF.CDPAIS = ESC.CDPAIS(+)) AND
          (EF.SGESTADO = ESC.SGESTADO(+)) AND
          (EF.CDPAIS = MEC.CDPAIS(+)) AND
          (EF.SGESTADO = MEC.SGESTADO(+)) AND
          (EF.CDMUNICIPIO = MEC.CDMUNICIPIO(+)) AND
          (T.CDPAIS = MT.CDPAIS(+)) AND
          (T.SGESTADO = MT.SGESTADO(+)) AND
          (T.CDMUNICIPIO = MT.CDMUNICIPIO(+)) AND
          (N.CDTIPOOPER = O.CDTIPOOPER(+)) AND
          (N.IDENTRSAIDOP = O.IDENTRSAIDOP(+)) AND
          (N.NRORG        = O.NRORG(+))        AND
          (N.CDEMPRESA = S.CDEMPRESA(+)) AND
          (N.CDINSCESTA = S.CDINSCESTA(+)) AND
          (N.CDINSCMUNI = S.CDINSCMUNI(+)) AND
          (N.CDSERIE = S.CDSERIE(+)) AND
          (N.NRORG   = S.NRORG(+))   AND
          (N.CDSERIEENTR = SE.CDSERIEENTR(+)) AND
          (N.NRORG       = SE.NRORG(+))
    ORDER BY N.CDFILIAL, N.NRLANCTONF
SQL;
            $params = array(
                "CDFILIAL" => $cdfilial,
                "NRLANCTONF" => $nrlanctonf,
                "NRORG" => $nrorg
            );
            return \Setforms2\Shared\Connection::getInstance()->fetchAll($sql, $params);
        }catch(\Exception $e){
            throw $e;
        }
    }

    public function consultaCorpoNFFornecedorEntrada($cdfilial, $nrlanctonf, $nrorg)
    {
        try{
            $sql = <<<SQL
    SELECT N.NRORG,N.CDFILIAL, F.NMFILIAL, N.NRLANCTONF, N.CDEMPRESA, E.CDCNAE, I.NMREPRINSEST,
           E.NMRAZSOCEMPR AS  NMRAZSOCEMIT, I.NRINSJURIEST AS NRINSJUREMIT, I.IDTPIJURIEST AS IDTPIJUREMIT, (I.SGESTADO) AS SGESTAEMIT, (ESE.CDESTADOIBGE) AS CDESTAIBGEEMIT,
           (MI.NMMUNICIPIO) AS NMMUNIEMIT, (MI.CDMUNICIBGE) AS CDMUNIIBGEEMIT, I.DSENDEIEST AS DSENDEEMIT,
           I.NMBAIRIEST AS NMBAIREMIT, I.NRCEPIEST AS NRCEPEMIT, I.NRTELEIEST AS NRTELEEMIT, I.NRFAXIEST AS NRFAXEMIT, N.CDINSCESTA AS NRINSCESTEMIT,
           ' ' AS DSCOMPENDEMIT, PE.CDPAIS AS CDPAISEMIT, PE.CDPAISBACEN AS CDPAISBACENEMIT, PE.NMPAIS AS NMPAISEMIT,
           FO.NMRAZSOCFORN AS NMRAZSOCCLIE, N.IDTPIJURNF AS IDTPIJURCLIE, N.NRINSJURNF AS NRINSJURCLIE, (EF.SGESTADO) AS SGESTACLIE, ESC.CDESTADOIBGE AS CDESTAIBGECLIE,
           (MEC.NMMUNICIPIO) AS NMMUNICLIE, (MEC.CDMUNICIBGE) AS CDMUNIIBGECLIE,  EF.DSENDEFORN AS DSENDECLIE,
           EF.NMBAIRFORN AS NMBAIRCLIE, EF.NRCEPFORN AS NRCEPCLIE, EF.NRTELEFORN AS NRTELECLIE, EF.NRFAXFORN AS NRFAXCLIE, FO.NRINSESTFORN AS NRINSCESTCLIE,
           EF.DSCOMPENDFOR AS DSCOMPENDCLI, PC.CDPAIS AS CDPAISCLIE, PC.CDPAISBACEN AS CDPAISBACENCLIE,  PC.NMPAIS AS NMPAISCLIE,
           N.NRNOTAFISC, NVL(N.DTEMISSAO, N.DTENTRSAID) DTEMISSAO, N.DTENTRSAID,
           DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(VRPRODUTOS, 2), '9999999999999.99')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(VRPRODUTOS, 2), '9999999999999.99')), LTRIM(TO_CHAR(ROUND(VRPRODUTOS, 2), '9999999999999.99'))) AS VRPRODUTOS,
           DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(VRNOTAFISC, 2), '9999999999999.99')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(VRNOTAFISC, 2), '9999999999999.99')), LTRIM(TO_CHAR(ROUND(VRNOTAFISC, 2), '9999999999999.99'))) AS VRNOTAFISC,
           N.NRPLACAVEIC, N.SGUFVEIC, N.IDPGTOFRETE,
           N.DSQTDEVOLU, N.DSESPECVOLU, N.DSMARCAVOLU, N.DSNUMEVOLU,
           DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(VRPLIQUVOLU, 3), '999999999999.999')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(VRPLIQUVOLU, 3), '999999999999.999')), LTRIM(TO_CHAR(ROUND(VRPLIQUVOLU, 3), '999999999999.999'))) AS VRPLIQUVOLU,
           DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(VRPBRUTOVOLU, 3), '999999999999.999')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(VRPBRUTOVOLU, 3), '999999999999.999')), LTRIM(TO_CHAR(ROUND(VRPBRUTOVOLU, 3), '999999999999.999'))) AS VRPBRUTOVOLU,
           I.NRSERIECERTIFIC, NVL(N.IDORIGDESTNF , 'F') IDORIGDESTNF, '' AS CDCLIENTE, N.CDFORNECED, '' AS CDFILIRECE,
           N.IDENTRSAIDOP, N.CDTIPOOPER, N.NRACESSONFE,
           N.IDSTATUSNFE, N.NRNOTAFISCALELE,  N.NRLOTENFE,
           NVL(N.DSCFOPINFUSU, N.DSCDFISOPENF) AS NMTIPOOPER, O.IDOPERDEVONF, I.IDTPIMPRESDANFE,
           NVL(S.CDSERIENFE, SE.CDSERIEENTRNFE) AS CDSERIE,
           S.DSSERIE AS DSSERIE, N.NRINSJURTRAN,
           N.IDTPIJURTRAN, T.NMRAZSOCTRAN, T.NRINSESTTRAN,
           (T.SGESTADO) AS SGESTATRAN, (MT.NMMUNICIPIO) AS NMMUNITRAN,
           T.DSENDETRAN, NVL(N.CDCFOPINFUSU, N.CDFISOPENTF) AS CDFISOPENTF, NVL(N.DSCFOPINFUSU, N.DSCDFISOPENF) AS DSCDFISOPENF, N.CDINSCMUNI,
           N.CDMODDOCFISC, N.IDTIPOEMISNFE,
           FO.NRINSCSUFRAMAFO AS NRINSCSUFRAMA,
           FO.NMFANTFORN AS NMFANT, EM.CDESTADOIBGE AS CDESTADOIBGEEMP,
           ME.CDMUNICIBGE AS CDMUNICIBGEEMP,
           E.SGESTADO AS SGESTADOEMP, N.CDINSCESTAST, EF.DSEMAILFORNNFE AS DSEMAILDEST, DTHRPROTOCOLNFE,
           NRREGDPECNFE, DTHRREGCONTNFE, CDBARRACONTING, IDBRINDETPOPER,
           NVL(S.CDSERIENFESCAN, SE.CDSERIEENTSCAN) AS CDSERIESCAN, NVL(O.IDNFESTCANC, 'N') IDNFESTCANC, NVL(O.IDNFAJUSTE, 'N') IDNFAJUSTE,
           N.IDSTATUS
    FROM  NOTAFISCAL N, TRANSPORT T, FORNECEDOR FO,
          ENDEFORN EF, FILIAL F, INSCRESTAD I,
          MUNICIPIO MI, MUNICIPIO MT, MUNICIPIO MEC, MUNICIPIO ME,
          TIPOOPERAC O, EMPRESA E, SERIENF S,
          ESTADO ESE, ESTADO ESC, ESTADO EM,
          PAIS PE, PAIS PC, SERIEENTR SE
    WHERE (N.CDFILIRECE = :CDFILIAL) AND
          (N.NRLANCTONF = :NRLANCTONF) AND
          (N.NRORG = :NRORG) AND
          (N.IDORIGDESTNF = 'F') AND
          (N.IDTPIJURTRAN = T.IDTPIJURTRAN(+)) AND
          (N.NRINSJURTRAN = T.NRINSJURTRAN(+)) AND
          (N.NRORG        = T.NRORG(+))        AND
          (N.CDFORNECED = FO.CDFORNECED(+)) AND
          (N.NRORG      = FO.NRORG(+))      AND
          (FO.CDFORNECED = EF.CDFORNECED(+)) AND
          (FO.NRORG      = EF.NRORG(+))      AND
          (EF.IDTPENDEFORN = NVL(FO.IDENDEMISFOR,'P')) AND
          (N.CDFILIAL = F.CDFILIAL) AND
          (N.NRORG    = F.NRORG)    AND
          (N.CDEMPRESA = E.CDEMPRESA) AND
          (N.NRORG     = E.NRORG)     AND
          (I.CDEMPRESA = E.CDEMPRESA) AND
          (I.NRORG     = E.NRORG)     AND
          (N.CDINSCESTA = I.CDINSCESTA) AND
          (N.NRORG      = I.NRORG)      AND
          (E.CDPAIS = EM.CDPAIS(+)) AND
          (E.SGESTADO = EM.SGESTADO(+)) AND
          (E.CDPAIS = ME.CDPAIS(+)) AND
          (E.SGESTADO = ME.SGESTADO(+)) AND
          (E.CDMUNICIPIO = ME.CDMUNICIPIO(+)) AND
          (I.CDPAIS = PE.CDPAIS) AND
          (I.CDPAIS = ESE.CDPAIS(+)) AND
          (I.SGESTADO = ESE.SGESTADO(+)) AND
          (I.CDPAIS = MI.CDPAIS(+)) AND
          (I.SGESTADO = MI.SGESTADO(+)) AND
          (I.CDMUNICIPIO = MI.CDMUNICIPIO(+)) AND
          (EF.CDPAIS = PC.CDPAIS(+)) AND
          (EF.CDPAIS = ESC.CDPAIS(+)) AND
          (EF.SGESTADO = ESC.SGESTADO(+)) AND
          (EF.CDPAIS = MEC.CDPAIS(+)) AND
          (EF.SGESTADO = MEC.SGESTADO(+)) AND
          (EF.CDMUNICIPIO = MEC.CDMUNICIPIO(+)) AND
          (T.CDPAIS = MT.CDPAIS(+)) AND
          (T.SGESTADO = MT.SGESTADO(+)) AND
          (T.CDMUNICIPIO = MT.CDMUNICIPIO(+)) AND
          (N.CDTIPOOPER = O.CDTIPOOPER(+)) AND
          (N.IDENTRSAIDOP = O.IDENTRSAIDOP(+)) AND
          (N.NRORG        = O.NRORG(+))        AND
          (N.CDEMPRESA = S.CDEMPRESA(+)) AND
          (N.CDINSCESTA = S.CDINSCESTA(+)) AND
          (N.CDINSCMUNI = S.CDINSCMUNI(+)) AND
          (N.CDSERIE = S.CDSERIE(+)) AND
          (N.NRORG   = S.NRORG(+))   AND
          (N.CDSERIEENTR = SE.CDSERIEENTR(+)) AND
          (N.NRORG       = SE.NRORG(+))
    ORDER BY N.CDFILIAL, N.NRLANCTONF
SQL;
            $params = array(
                "CDFILIAL" => $cdfilial,
                "NRLANCTONF" => $nrlanctonf,
                "NRORG" => $nrorg
            );
            return \Setforms2\Shared\Connection::getInstance()->fetchAll($sql, $params);
        }catch(\Exception $e){
            throw $e;
        }
    }

    public function consultaCorpoNFFilial($cdfilial, $nrlanctonf, $nrorg)
    {
        try{
            $sql = <<<SQL
    SELECT N.NRORG,N.CDFILIAL, F.NMFILIAL, N.NRLANCTONF, N.NRNOTAFISCALELE, N.CDEMPRESA, E.CDCNAE, I.NMREPRINSEST,
           E.NMRAZSOCEMPR AS NMRAZSOCEMIT, I.NRINSJURIEST AS NRINSJUREMIT, I.IDTPIJURIEST AS IDTPIJUREMIT, (I.SGESTADO) AS SGESTAEMIT, (ESE.CDESTADOIBGE) AS CDESTAIBGEEMIT,
           (MI.NMMUNICIPIO) AS NMMUNIEMIT, (MI.CDMUNICIBGE) AS CDMUNIIBGEEMIT, I.DSENDEIEST AS DSENDEEMIT,
           I.NMBAIRIEST AS NMBAIREMIT, I.NRCEPIEST AS NRCEPEMIT, I.NRTELEIEST AS NRTELEEMIT, I.NRFAXIEST AS NRFAXEMIT, N.CDINSCESTA AS NRINSCESTEMIT,
           ' ' AS DSCOMPENDEMIT, PE.CDPAIS AS CDPAISEMIT, PE.CDPAISBACEN AS CDPAISBACENEMIT, PE.NMPAIS AS NMPAISEMIT,
           FR.NMRAZSOCFILI AS NMRAZSOCCLIE, N.NRINSJURNF AS NRINSJURCLIE, N.IDTPIJURNF AS IDTPIJURCLIE, (EF.SGESTADO) AS SGESTACLIE, ESC.CDESTADOIBGE AS CDESTAIBGECLIE,
           (MEC.NMMUNICIPIO) AS NMMUNICLIE, (MEC.CDMUNICIBGE) AS CDMUNIIBGECLIE, EF.DSENDEFILI AS DSENDECLIE,
           EF.NMBAIRFILI AS NMBAIRCLIE, EF.NRCEPFILI AS NRCEPCLIE, EF.NRTELEFILI AS NRTELECLIE, EF.NRFAXFILI AS NRFAXCLIE,  FR.CDINSCESTA AS NRINSCESTCLIE,
           EF.DSCOMPENDFIL AS DSCOMPENDCLI, PC.CDPAIS AS CDPAISCLIE, PC.CDPAISBACEN AS CDPAISBACENCLIE, PC.NMPAIS AS NMPAISCLIE,
           NVL(N.DTEMISSAO, N.DTENTRSAID) DTEMISSAO, N.DTENTRSAID, N.NRNOTAFISC,
           DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(VRPRODUTOS, 2), '9999999999999.99')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(VRPRODUTOS, 2), '9999999999999.99')), LTRIM(TO_CHAR(ROUND(VRPRODUTOS, 2), '9999999999999.99'))) AS VRPRODUTOS,
           DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(VRNOTAFISC, 2), '9999999999999.99')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(VRNOTAFISC, 2), '9999999999999.99')), LTRIM(TO_CHAR(ROUND(VRNOTAFISC, 2), '9999999999999.99'))) AS VRNOTAFISC,
           N.NRPLACAVEIC, N.SGUFVEIC, N.IDPGTOFRETE,
           N.DSQTDEVOLU, N.DSESPECVOLU, N.DSMARCAVOLU, N.DSNUMEVOLU,
           DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(VRPLIQUVOLU, 3), '999999999999.999')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(VRPLIQUVOLU, 3), '999999999999.999')), LTRIM(TO_CHAR(ROUND(VRPLIQUVOLU, 3), '999999999999.999'))) AS VRPLIQUVOLU,
           DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(VRPBRUTOVOLU, 3), '999999999999.999')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(VRPBRUTOVOLU, 3), '999999999999.999')), LTRIM(TO_CHAR(ROUND(VRPBRUTOVOLU, 3), '999999999999.999'))) AS VRPBRUTOVOLU,
           I.NRSERIECERTIFIC, NVL(N.IDORIGDESTNF , 'L') IDORIGDESTNF, '' AS CDCLIENTE, '' AS CDFORNECED, N.CDFILIRECE,
           N.IDENTRSAIDOP, N.CDTIPOOPER, N.NRACESSONFE,
           NVL(N.DSCFOPINFUSU, N.DSCDFISOPENF) AS NMTIPOOPER,  O.IDOPERDEVONF, I.IDTPIMPRESDANFE,
           NVL(S.CDSERIENFE, SE.CDSERIEENTRNFE) AS CDSERIE,
           S.DSSERIE AS DSSERIE, N.NRINSJURTRAN,
           N.IDTPIJURTRAN, T.NMRAZSOCTRAN, T.NRINSESTTRAN,
           (T.SGESTADO) AS SGESTATRAN, (MT.NMMUNICIPIO) AS NMMUNITRAN,
           T.DSENDETRAN, NVL(N.CDCFOPINFUSU, N.CDFISOPENTF) AS CDFISOPENTF, NVL(N.DSCFOPINFUSU, N.DSCDFISOPENF) AS DSCDFISOPENF, N.CDINSCMUNI,
           N.CDMODDOCFISC, N.IDTIPOEMISNFE,
           FR.NRINSCSUFRAMAFI AS NRINSCSUFRAMA,
           FR.NMRAZSOCFILI AS NMFANT, EM.CDESTADOIBGE AS CDESTADOIBGEEMP,
           ME.CDMUNICIBGE AS CDMUNICIBGEEMP,
           E.SGESTADO AS SGESTADOEMP, N.CDINSCESTAST, EFE.DSEMAILEMXMLNFE AS DSEMAILDEST, DTHRPROTOCOLNFE,
           NRREGDPECNFE, DTHRREGCONTNFE, CDBARRACONTING, IDBRINDETPOPER,
           NVL(S.CDSERIENFESCAN, SE.CDSERIEENTSCAN) AS CDSERIESCAN, NVL(O.IDNFESTCANC, 'N') IDNFESTCANC, NVL(O.IDNFAJUSTE, 'N') IDNFAJUSTE,
           N.IDSTATUS
    FROM  NOTAFISCAL N, FILIAL F, EMPRESA E, ESTADO EM, MUNICIPIO ME,INSCRESTAD I, PAIS PE,ESTADO ESE,MUNICIPIO MI,
          FILIAL FR,ENDEFILI EF,PAIS PC,ESTADO ESC,MUNICIPIO MEC, ENDEFILI EFE,
          TRANSPORT T, MUNICIPIO MT,
          TIPOOPERAC O,  SERIENF S, SERIEENTR SE
    WHERE (N.CDFILIEMIT = :CDFILIAL) AND
          (N.NRLANCTONF = :NRLANCTONF) AND
          (N.IDORIGDESTNF = 'L') AND
          (N.CDFILIAL = F.CDFILIAL) AND
          (N.NRORG    = F.NRORG)    AND
          (N.CDEMPRESA = E.CDEMPRESA) AND
          (N.NRORG     = E.NRORG)     AND
          (E.CDPAIS = EM.CDPAIS(+)) AND
          (E.SGESTADO = EM.SGESTADO(+)) AND
          (E.CDPAIS = ME.CDPAIS(+)) AND
          (E.SGESTADO = ME.SGESTADO(+)) AND
          (E.CDMUNICIPIO = ME.CDMUNICIPIO(+)) AND
          (I.CDEMPRESA = E.CDEMPRESA) AND
          (I.NRORG     = E.NRORG)     AND
          (N.CDINSCESTA = I.CDINSCESTA) AND
          (N.NRORG      = I.NRORG)      AND
          (I.CDPAIS = PE.CDPAIS(+)) AND
          (I.CDPAIS = ESE.CDPAIS(+)) AND
          (I.SGESTADO = ESE.SGESTADO(+)) AND
          (I.CDPAIS = MI.CDPAIS(+)) AND
          (I.SGESTADO = MI.SGESTADO(+)) AND
          (I.CDMUNICIPIO = MI.CDMUNICIPIO(+)) AND
          (N.CDFILIRECE = FR.CDFILIAL(+)) AND
          (N.NRORG      = FR.NRORG(+))    AND
          (FR.CDFILIAL = EF.CDFILIAL(+)) AND
          (FR.NRORG    = EF.NRORG(+))    AND
          (EF.IDTPENDEFILI = FR.IDENDEMISFIL) AND
          (EF.CDPAIS = PC.CDPAIS(+)) AND
          (EF.CDPAIS = ESC.CDPAIS(+)) AND
          (EF.SGESTADO = ESC.SGESTADO(+)) AND
          (EF.CDPAIS = MEC.CDPAIS(+)) AND
          (EF.SGESTADO = MEC.SGESTADO(+)) AND
          (EF.CDMUNICIPIO = MEC.CDMUNICIPIO(+)) AND
          (FR.CDFILIAL = EFE.CDFILIAL(+)) AND
          (FR.NRORG    = EFE.NRORG(+))    AND
          (EFE.IDTPENDEFILI = 'P') AND
          (N.IDTPIJURTRAN = T.IDTPIJURTRAN(+)) AND
          (N.NRINSJURTRAN = T.NRINSJURTRAN(+)) AND
          (N.NRORG        = T.NRORG(+))        AND
          (T.CDPAIS = MT.CDPAIS(+)) AND
          (T.SGESTADO = MT.SGESTADO(+)) AND
          (T.CDMUNICIPIO = MT.CDMUNICIPIO(+)) AND
          (N.CDTIPOOPER = O.CDTIPOOPER(+)) AND
          (N.IDENTRSAIDOP = O.IDENTRSAIDOP(+)) AND
          (N.NRORG        = O.NRORG(+))        AND
          (N.CDEMPRESA = S.CDEMPRESA(+)) AND
          (N.CDINSCESTA = S.CDINSCESTA(+)) AND
          (N.CDINSCMUNI = S.CDINSCMUNI(+)) AND
          (N.CDSERIE = S.CDSERIE(+)) AND
          (N.NRORG   = S.NRORG(+))   AND
          (N.NRORG       = SE.NRORG(+)) AND
          (N.CDSERIEENTR = SE.CDSERIEENTR(+))
    UNION ALL
    SELECT N.NRORG,N.CDFILIAL, F.NMFILIAL, N.NRLANCTONF, N.CDEMPRESA, E.CDCNAE, I.NMREPRINSEST,
           E.NMRAZSOCEMPR AS NMRAZSOCEMIT, I.NRINSJURIEST AS NRINSJUREMIT, I.IDTPIJURIEST AS IDTPIJUREMIT, (I.SGESTADO) AS SGESTAEMIT, (ESE.CDESTADOIBGE) AS CDESTAIBGEEMIT,
           (MI.NMMUNICIPIO) AS NMMUNIEMIT, (MI.CDMUNICIBGE) AS CDMUNIIBGEEMIT, I.DSENDEIEST AS DSENDEEMIT,
           I.NMBAIRIEST AS NMBAIREMIT, I.NRCEPIEST AS NRCEPEMIT, I.NRTELEIEST AS NRTELEEMIT, I.NRFAXIEST AS NRFAXEMIT, N.CDINSCESTA AS NRINSCESTEMIT,
           ' ' AS DSCOMPENDEMIT, PE.CDPAIS AS CDPAISEMIT, PE.CDPAISBACEN AS CDPAISBACENEMIT, PE.NMPAIS AS NMPAISEMIT,
           FR.NMRAZSOCFILI AS NMRAZSOCCLIE, N.NRINSJURNF AS NRINSJURCLIE, N.IDTPIJURNF AS IDTPIJURCLIE, (IR.SGESTADO) AS SGESTACLIE, ESC.CDESTADOIBGE AS CDESTAIBGECLIE,
           (MEC.NMMUNICIPIO) AS NMMUNICLIE, (MEC.CDMUNICIBGE) AS CDMUNIIBGECLIE, IR.DSENDEIEST AS DSENDECLIE,
           IR.NMBAIRIEST AS NMBAIRCLIE, IR.NRCEPIEST AS NRCEPCLIE, IR.NRTELEIEST AS NRTELECLIE, IR.NRFAXIEST AS NRFAXCLIE,  FR.CDINSCESTA AS NRINSCESTCLIE,
           IR.DSCOMPENDIES AS DSCOMPENDCLI, PC.CDPAIS AS CDPAISCLIE, PC.CDPAISBACEN AS CDPAISBACENCLIE, PC.NMPAIS AS NMPAISCLIE,
           NVL(N.DTEMISSAO, N.DTENTRSAID) DTEMISSAO, N.DTENTRSAID, N.NRNOTAFISC,
           DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(VRPRODUTOS, 2), '9999999999999.99')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(VRPRODUTOS, 2), '9999999999999.99')), LTRIM(TO_CHAR(ROUND(VRPRODUTOS, 2), '9999999999999.99'))) AS VRPRODUTOS,
           DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(VRNOTAFISC, 2), '9999999999999.99')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(VRNOTAFISC, 2), '9999999999999.99')), LTRIM(TO_CHAR(ROUND(VRNOTAFISC, 2), '9999999999999.99'))) AS VRNOTAFISC,
           N.NRPLACAVEIC, N.SGUFVEIC, N.IDPGTOFRETE,
           N.DSQTDEVOLU, N.DSESPECVOLU, N.DSMARCAVOLU, N.DSNUMEVOLU,
           DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(VRPLIQUVOLU, 3), '999999999999.999')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(VRPLIQUVOLU, 3), '999999999999.999')), LTRIM(TO_CHAR(ROUND(VRPLIQUVOLU, 3), '999999999999.999'))) AS VRPLIQUVOLU,
           DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(VRPBRUTOVOLU, 3), '999999999999.999')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(VRPBRUTOVOLU, 3), '999999999999.999')), LTRIM(TO_CHAR(ROUND(VRPBRUTOVOLU, 3), '999999999999.999'))) AS VRPBRUTOVOLU,
           I.NRSERIECERTIFIC, NVL(N.IDORIGDESTNF , 'L') IDORIGDESTNF, '' AS CDCLIENTE, '' AS CDFORNECED, N.CDFILIRECE,
           N.IDENTRSAIDOP, N.CDTIPOOPER, N.NRACESSONFE,
           NVL(N.DSCFOPINFUSU, N.DSCDFISOPENF) AS NMTIPOOPER,  O.IDOPERDEVONF, I.IDTPIMPRESDANFE,
           NVL(S.CDSERIENFE, SE.CDSERIEENTRNFE) AS CDSERIE,
           S.DSSERIE AS DSSERIE, N.NRINSJURTRAN,
           N.IDTPIJURTRAN, T.NMRAZSOCTRAN, T.NRINSESTTRAN,
           (T.SGESTADO) AS SGESTATRAN, (MT.NMMUNICIPIO) AS NMMUNITRAN,
           T.DSENDETRAN, NVL(N.CDCFOPINFUSU, N.CDFISOPENTF) AS CDFISOPENTF, NVL(N.DSCFOPINFUSU, N.DSCDFISOPENF) AS DSCDFISOPENF, N.CDINSCMUNI,
           N.CDMODDOCFISC, N.IDTIPOEMISNFE,
           FR.NRINSCSUFRAMAFI AS NRINSCSUFRAMA,
           FR.NMRAZSOCFILI AS NMFANT, EM.CDESTADOIBGE AS CDESTADOIBGEEMP,
           ME.CDMUNICIBGE AS CDMUNICIBGEEMP,
           E.SGESTADO AS SGESTADOEMP, N.CDINSCESTAST, EF.DSEMAILEMXMLNFE AS DSEMAILDEST, DTHRPROTOCOLNFE,
           NRREGDPECNFE, DTHRREGCONTNFE, CDBARRACONTING, IDBRINDETPOPER,
           NVL(S.CDSERIENFESCAN, SE.CDSERIEENTSCAN) AS CDSERIESCAN, NVL(O.IDNFESTCANC, 'N') IDNFESTCANC, NVL(O.IDNFAJUSTE, 'N') IDNFAJUSTE,
           N.IDSTATUS
    FROM  NOTAFISCAL N, FILIAL F, EMPRESA E, ESTADO EM, MUNICIPIO ME,INSCRESTAD I, PAIS PE,ESTADO ESE,MUNICIPIO MI,
          FILIAL FR, INSCRESTAD IR, PAIS PC,ESTADO ESC, MUNICIPIO MEC,ENDEFILI EF,
          TRANSPORT T, MUNICIPIO MT,
          TIPOOPERAC O,  SERIENF S, SERIEENTR SE
    WHERE (N.CDFILIAL = :CDFILIAL) AND
          (N.NRLANCTONF = :NRLANCTONF) AND
          (N.NRORG = :NRORG) AND
          (N.IDORIGDESTNF = 'L') AND
          (N.CDFILIAL = F.CDFILIAL) AND
          (N.NRORG    = F.NRORG)    AND
          (N.CDEMPRESA = E.CDEMPRESA) AND
          (N.NRORG     = E.NRORG)     AND
          (E.CDPAIS = EM.CDPAIS(+)) AND
          (E.SGESTADO = EM.SGESTADO(+)) AND
          (E.CDPAIS = ME.CDPAIS(+)) AND
          (E.SGESTADO = ME.SGESTADO(+)) AND
          (E.CDMUNICIPIO = ME.CDMUNICIPIO(+)) AND
          (I.CDEMPRESA = E.CDEMPRESA) AND
          (I.NRORG     = E.NRORG)     AND
          (N.CDINSCESTA = I.CDINSCESTA) AND
          (N.NRORG      = I.NRORG)      AND
          (I.CDPAIS = PE.CDPAIS(+)) AND
          (I.CDPAIS = ESE.CDPAIS(+)) AND
          (I.SGESTADO = ESE.SGESTADO(+)) AND
          (I.CDPAIS = MI.CDPAIS(+)) AND
          (I.SGESTADO = MI.SGESTADO(+)) AND
          (I.CDMUNICIPIO = MI.CDMUNICIPIO(+)) AND
          (N.CDFILIRECE = FR.CDFILIAL(+)) AND
          (N.NRORG      = FR.NRORG(+))    AND
          (FR.IDENDEMISFIL IS NULL) and
          (IR.CDEMPRESA  = FR.CDEMPRESA) and
          (IR.CDINSCESTA = FR.CDINSCESTA) and
          (IR.NRORG      = FR.NRORG)      AND
          (IR.CDPAIS = PC.CDPAIS(+)) AND
          (IR.CDPAIS = ESC.CDPAIS(+)) AND
          (IR.SGESTADO = ESC.SGESTADO(+)) AND
          (IR.CDPAIS = MEC.CDPAIS(+)) and
          (IR.SGESTADO = MEC.SGESTADO(+)) and
          (IR.CDMUNICIPIO = MEC.CDMUNICIPIO(+)) and
          (FR.CDFILIAL = EF.CDFILIAL(+)) AND
          (FR.NRORG    = EF.NRORG(+))    AND
          (EF.IDTPENDEFILI = 'P') AND
          (N.IDTPIJURTRAN = T.IDTPIJURTRAN(+)) AND
          (N.NRINSJURTRAN = T.NRINSJURTRAN(+)) AND
          (N.NRORG        = T.NRORG(+))        AND
          (T.CDPAIS = MT.CDPAIS(+)) AND
          (T.SGESTADO = MT.SGESTADO(+)) AND
          (T.CDMUNICIPIO = MT.CDMUNICIPIO(+)) AND
          (N.CDTIPOOPER = O.CDTIPOOPER(+)) AND
          (N.IDENTRSAIDOP = O.IDENTRSAIDOP(+)) AND
          (N.NRORG        = O.NRORG(+))        AND
          (N.CDEMPRESA = S.CDEMPRESA(+)) AND
          (N.CDINSCESTA = S.CDINSCESTA(+)) AND
          (N.CDINSCMUNI = S.CDINSCMUNI(+)) AND
          (N.CDSERIE = S.CDSERIE(+)) AND
          (N.NRORG   = S.NRORG(+))   AND
          (N.NRORG       = SE.NRORG(+)) AND
          (N.CDSERIEENTR = SE.CDSERIEENTR(+))
    ORDER BY 1,3

SQL;

            $params = array(
                "CDFILIAL" => $cdfilial,
                "NRLANCTONF" => $nrlanctonf,
                "NRORG" => $nrorg
            );
            return \Setforms2\Shared\Connection::getInstance()->fetchAll($sql, $params);
        }catch(\Exception $e){
            throw $e;
        }
    }

    public function consultaCorpoNFFilialEntrada($cdfilial ,$nrlanctonf, $nrorg)
    {
        try{
            $sql = <<<SQL
    SELECT N.NRORG,N.CDFILIAL, F.NMFILIAL, N.NRLANCTONF, N.NRNOTAFISCALELE, N.CDEMPRESA, E.CDCNAE, I.NMREPRINSEST,
           E.NMRAZSOCEMPR AS NMRAZSOCEMIT, I.NRINSJURIEST AS NRINSJUREMIT, I.IDTPIJURIEST AS IDTPIJUREMIT, (I.SGESTADO) AS SGESTAEMIT, (ESE.CDESTADOIBGE) AS CDESTAIBGEEMIT,
           (MI.NMMUNICIPIO) AS NMMUNIEMIT, (MI.CDMUNICIBGE) AS CDMUNIIBGEEMIT, I.DSENDEIEST AS DSENDEEMIT,
           I.NMBAIRIEST AS NMBAIREMIT, I.NRCEPIEST AS NRCEPEMIT, I.NRTELEIEST AS NRTELEEMIT, I.NRFAXIEST AS NRFAXEMIT, N.CDINSCESTA AS NRINSCESTEMIT,
           ' ' AS DSCOMPENDEMIT, PE.CDPAIS AS CDPAISEMIT, PE.CDPAISBACEN AS CDPAISBACENEMIT, PE.NMPAIS AS NMPAISEMIT,
           FR.NMRAZSOCFILI AS NMRAZSOCCLIE, N.NRINSJURNF AS NRINSJURCLIE, N.IDTPIJURNF AS IDTPIJURCLIE, (EF.SGESTADO) AS SGESTACLIE, ESC.CDESTADOIBGE AS CDESTAIBGECLIE,
           (MEC.NMMUNICIPIO) AS NMMUNICLIE, (MEC.CDMUNICIBGE) AS CDMUNIIBGECLIE, EF.DSENDEFILI AS DSENDECLIE,
           EF.NMBAIRFILI AS NMBAIRCLIE, EF.NRCEPFILI AS NRCEPCLIE, EF.NRTELEFILI AS NRTELECLIE, EF.NRFAXFILI AS NRFAXCLIE,  FR.CDINSCESTA AS NRINSCESTCLIE,
           EF.DSCOMPENDFIL AS DSCOMPENDCLI, PC.CDPAIS AS CDPAISCLIE, PC.CDPAISBACEN AS CDPAISBACENCLIE, PC.NMPAIS AS NMPAISCLIE,
           NVL(N.DTEMISSAO, N.DTENTRSAID) DTEMISSAO, N.DTENTRSAID, N.NRNOTAFISC,
           DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(VRPRODUTOS, 2), '9999999999999.99')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(VRPRODUTOS, 2), '9999999999999.99')), LTRIM(TO_CHAR(ROUND(VRPRODUTOS, 2), '9999999999999.99'))) AS VRPRODUTOS,
           DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(VRNOTAFISC, 2), '9999999999999.99')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(VRNOTAFISC, 2), '9999999999999.99')), LTRIM(TO_CHAR(ROUND(VRNOTAFISC, 2), '9999999999999.99'))) AS VRNOTAFISC,
           N.NRPLACAVEIC, N.SGUFVEIC, N.IDPGTOFRETE,
           N.DSQTDEVOLU, N.DSESPECVOLU, N.DSMARCAVOLU, N.DSNUMEVOLU,
           DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(VRPLIQUVOLU, 3), '999999999999.999')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(VRPLIQUVOLU, 3), '999999999999.999')), LTRIM(TO_CHAR(ROUND(VRPLIQUVOLU, 3), '999999999999.999'))) AS VRPLIQUVOLU,
           DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(VRPBRUTOVOLU, 3), '999999999999.999')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(VRPBRUTOVOLU, 3), '999999999999.999')), LTRIM(TO_CHAR(ROUND(VRPBRUTOVOLU, 3), '999999999999.999'))) AS VRPBRUTOVOLU,
           I.NRSERIECERTIFIC, NVL(N.IDORIGDESTNF , 'L') IDORIGDESTNF, '' AS CDCLIENTE, '' AS CDFORNECED, N.CDFILIEMIT AS CDFILIRECE,
           N.IDENTRSAIDOP, N.CDTIPOOPER, N.NRACESSONFE,
           NVL(N.DSCFOPINFUSU, N.DSCDFISOPENF) AS NMTIPOOPER,  O.IDOPERDEVONF, I.IDTPIMPRESDANFE,
           NVL(S.CDSERIENFE, SE.CDSERIEENTRNFE) AS CDSERIE,
           S.DSSERIE AS DSSERIE, N.NRINSJURTRAN,
           N.IDTPIJURTRAN, T.NMRAZSOCTRAN, T.NRINSESTTRAN,
           (T.SGESTADO) AS SGESTATRAN, (MT.NMMUNICIPIO) AS NMMUNITRAN,
           T.DSENDETRAN, NVL(N.CDCFOPINFUSU, N.CDFISOPENTF) AS CDFISOPENTF, NVL(N.DSCFOPINFUSU, N.DSCDFISOPENF) AS DSCDFISOPENF, N.CDINSCMUNI,
           N.CDMODDOCFISC, N.IDTIPOEMISNFE,
           FR.NRINSCSUFRAMAFI AS NRINSCSUFRAMA,
           FR.NMRAZSOCFILI AS NMFANT, EM.CDESTADOIBGE AS CDESTADOIBGEEMP,
           ME.CDMUNICIBGE AS CDMUNICIBGEEMP,
           E.SGESTADO AS SGESTADOEMP, N.CDINSCESTAST, EFE.DSEMAILEMXMLNFE AS DSEMAILDEST, DTHRPROTOCOLNFE,
           NRREGDPECNFE, DTHRREGCONTNFE, CDBARRACONTING, IDBRINDETPOPER,
           NVL(S.CDSERIENFESCAN, SE.CDSERIEENTSCAN) AS CDSERIESCAN, NVL(O.IDNFESTCANC, 'N') IDNFESTCANC, NVL(O.IDNFAJUSTE, 'N') IDNFAJUSTE,
           N.IDSTATUS
    FROM  NOTAFISCAL N, FILIAL F, EMPRESA E, ESTADO EM, MUNICIPIO ME,INSCRESTAD I, PAIS PE,ESTADO ESE,MUNICIPIO MI,
          FILIAL FR,ENDEFILI EF,PAIS PC,ESTADO ESC,MUNICIPIO MEC, ENDEFILI EFE,
          TRANSPORT T, MUNICIPIO MT,
          TIPOOPERAC O,  SERIENF S, SERIEENTR SE
    WHERE (N.CDFILIRECE = :CDFILIAL) AND
          (N.NRLANCTONF = :NRLANCTONF) AND
          (N.NRORG      = :NRORG)      AND
          (N.IDORIGDESTNF = 'L') AND
          (N.CDFILIAL = F.CDFILIAL) AND
          (N.NRORG    = F.NRORG)    AND
          (N.CDEMPRESA = E.CDEMPRESA) AND
          (N.NRORG     = E.NRORG)     AND
          (E.CDPAIS = EM.CDPAIS(+)) AND
          (E.SGESTADO = EM.SGESTADO(+)) AND
          (E.CDPAIS = ME.CDPAIS(+)) AND
          (E.SGESTADO = ME.SGESTADO(+)) AND
          (E.CDMUNICIPIO = ME.CDMUNICIPIO(+)) AND
          (I.CDEMPRESA = E.CDEMPRESA) AND
          (I.NRORG     = E.NRORG)     AND
          (N.CDINSCESTA = I.CDINSCESTA) AND
          (N.NRORG      = I.NRORG)      AND
          (I.CDPAIS = PE.CDPAIS(+)) AND
          (I.CDPAIS = ESE.CDPAIS(+)) AND
          (I.SGESTADO = ESE.SGESTADO(+)) AND
          (I.CDPAIS = MI.CDPAIS(+)) AND
          (I.SGESTADO = MI.SGESTADO(+)) AND
          (I.CDMUNICIPIO = MI.CDMUNICIPIO(+)) AND
          (N.CDFILIEMIT = FR.CDFILIAL(+)) AND
          (N.NRORG      = FR.NRORG(+))    AND
          (FR.CDFILIAL = EF.CDFILIAL(+)) AND
          (FR.NRORG   = EF.NRORG(+))        AND
          (EF.IDTPENDEFILI = FR.IDENDEMISFIL) AND
          (EF.CDPAIS = PC.CDPAIS(+)) AND
          (EF.CDPAIS = ESC.CDPAIS(+)) AND
          (EF.SGESTADO = ESC.SGESTADO(+)) AND
          (EF.CDPAIS = MEC.CDPAIS(+)) AND
          (EF.SGESTADO = MEC.SGESTADO(+)) AND
          (EF.CDMUNICIPIO = MEC.CDMUNICIPIO(+)) AND
          (FR.CDFILIAL = EFE.CDFILIAL(+)) AND
          (EFE.IDTPENDEFILI = 'P') AND
          (N.IDTPIJURTRAN = T.IDTPIJURTRAN(+)) AND
          (N.NRINSJURTRAN = T.NRINSJURTRAN(+)) AND
          (N.NRORG        = T.NRORG(+))        AND
          (T.CDPAIS = MT.CDPAIS(+)) AND
          (T.SGESTADO = MT.SGESTADO(+)) AND
          (T.CDMUNICIPIO = MT.CDMUNICIPIO(+)) AND
          (N.CDTIPOOPER = O.CDTIPOOPER(+)) AND
          (N.IDENTRSAIDOP = O.IDENTRSAIDOP(+)) AND
          (N.NRORG        = O.NRORG(+))        AND
          (N.CDEMPRESA = S.CDEMPRESA(+)) AND
          (N.CDINSCESTA = S.CDINSCESTA(+)) AND
          (N.CDINSCMUNI = S.CDINSCMUNI(+)) AND
          (N.CDSERIE = S.CDSERIE(+)) AND
          (N.NRORG   = S.NRORG(+))   AND
          (N.NRORG       = SE.NRORG(+)) AND
          (N.CDSERIEENTR = SE.CDSERIEENTR(+))
    UNION ALL
    SELECT N.NRORG,N.CDFILIAL, F.NMFILIAL, N.NRLANCTONF, N.CDEMPRESA, E.CDCNAE, I.NMREPRINSEST,
           E.NMRAZSOCEMPR AS NMRAZSOCEMIT, I.NRINSJURIEST AS NRINSJUREMIT, I.IDTPIJURIEST AS IDTPIJUREMIT, (I.SGESTADO) AS SGESTAEMIT, (ESE.CDESTADOIBGE) AS CDESTAIBGEEMIT,
           (MI.NMMUNICIPIO) AS NMMUNIEMIT, (MI.CDMUNICIBGE) AS CDMUNIIBGEEMIT, I.DSENDEIEST AS DSENDEEMIT,
           I.NMBAIRIEST AS NMBAIREMIT, I.NRCEPIEST AS NRCEPEMIT, I.NRTELEIEST AS NRTELEEMIT, I.NRFAXIEST AS NRFAXEMIT, N.CDINSCESTA AS NRINSCESTEMIT,
           ' ' AS DSCOMPENDEMIT, PE.CDPAIS AS CDPAISEMIT, PE.CDPAISBACEN AS CDPAISBACENEMIT, PE.NMPAIS AS NMPAISEMIT,
           FR.NMRAZSOCFILI AS NMRAZSOCCLIE, N.NRINSJURNF AS NRINSJURCLIE, N.IDTPIJURNF AS IDTPIJURCLIE, (IR.SGESTADO) AS SGESTACLIE, ESC.CDESTADOIBGE AS CDESTAIBGECLIE,
           (MEC.NMMUNICIPIO) AS NMMUNICLIE, (MEC.CDMUNICIBGE) AS CDMUNIIBGECLIE, IR.DSENDEIEST AS DSENDECLIE,
           IR.NMBAIRIEST AS NMBAIRCLIE, IR.NRCEPIEST AS NRCEPCLIE, IR.NRTELEIEST AS NRTELECLIE, IR.NRFAXIEST AS NRFAXCLIE,  FR.CDINSCESTA AS NRINSCESTCLIE,
           IR.DSCOMPENDIES AS DSCOMPENDCLI, PC.CDPAIS AS CDPAISCLIE, PC.CDPAISBACEN AS CDPAISBACENCLIE, PC.NMPAIS AS NMPAISCLIE,
           NVL(N.DTEMISSAO, N.DTENTRSAID) DTEMISSAO, N.DTENTRSAID, N.NRNOTAFISC,
           DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(VRPRODUTOS, 2), '9999999999999.99')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(VRPRODUTOS, 2), '9999999999999.99')), LTRIM(TO_CHAR(ROUND(VRPRODUTOS, 2), '9999999999999.99'))) AS VRPRODUTOS,
           DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(VRNOTAFISC, 2), '9999999999999.99')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(VRNOTAFISC, 2), '9999999999999.99')), LTRIM(TO_CHAR(ROUND(VRNOTAFISC, 2), '9999999999999.99'))) AS VRNOTAFISC,
           N.NRPLACAVEIC, N.SGUFVEIC, N.IDPGTOFRETE,
           N.DSQTDEVOLU, N.DSESPECVOLU, N.DSMARCAVOLU, N.DSNUMEVOLU,
           DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(VRPLIQUVOLU, 3), '999999999999.999')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(VRPLIQUVOLU, 3), '999999999999.999')), LTRIM(TO_CHAR(ROUND(VRPLIQUVOLU, 3), '999999999999.999'))) AS VRPLIQUVOLU,
           DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(VRPBRUTOVOLU, 3), '999999999999.999')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(VRPBRUTOVOLU, 3), '999999999999.999')), LTRIM(TO_CHAR(ROUND(VRPBRUTOVOLU, 3), '999999999999.999'))) AS VRPBRUTOVOLU,
           I.NRSERIECERTIFIC, NVL(N.IDORIGDESTNF , 'L') IDORIGDESTNF, '' AS CDCLIENTE, '' AS CDFORNECED, N.CDFILIEMIT AS CDFILIRECE,
           N.IDENTRSAIDOP, N.CDTIPOOPER, N.NRACESSONFE,
           NVL(N.DSCFOPINFUSU, N.DSCDFISOPENF) AS NMTIPOOPER,  O.IDOPERDEVONF, I.IDTPIMPRESDANFE,
           NVL(S.CDSERIENFE, SE.CDSERIEENTRNFE) AS CDSERIE,
           S.DSSERIE AS DSSERIE, N.NRINSJURTRAN,
           N.IDTPIJURTRAN, T.NMRAZSOCTRAN, T.NRINSESTTRAN,
           (T.SGESTADO) AS SGESTATRAN, (MT.NMMUNICIPIO) AS NMMUNITRAN,
           T.DSENDETRAN, NVL(N.CDCFOPINFUSU, N.CDFISOPENTF) AS CDFISOPENTF, NVL(N.DSCFOPINFUSU, N.DSCDFISOPENF) AS DSCDFISOPENF, N.CDINSCMUNI,
           N.CDMODDOCFISC, N.IDTIPOEMISNFE,
           FR.NRINSCSUFRAMAFI AS NRINSCSUFRAMA,
           FR.NMRAZSOCFILI AS NMFANT, EM.CDESTADOIBGE AS CDESTADOIBGEEMP,
           ME.CDMUNICIBGE AS CDMUNICIBGEEMP,
           E.SGESTADO AS SGESTADOEMP, N.CDINSCESTAST, EF.DSEMAILEMXMLNFE AS DSEMAILDEST, DTHRPROTOCOLNFE,
           NRREGDPECNFE, DTHRREGCONTNFE, CDBARRACONTING, IDBRINDETPOPER,
           NVL(S.CDSERIENFESCAN, SE.CDSERIEENTSCAN) AS CDSERIESCAN, NVL(O.IDNFESTCANC, 'N') IDNFESTCANC, NVL(O.IDNFAJUSTE, 'N') IDNFAJUSTE,
           N.IDSTATUS
    FROM  NOTAFISCAL N, FILIAL F, EMPRESA E, ESTADO EM, MUNICIPIO ME,INSCRESTAD I, PAIS PE,ESTADO ESE,MUNICIPIO MI,
          FILIAL FR, INSCRESTAD IR, PAIS PC,ESTADO ESC, MUNICIPIO MEC,ENDEFILI EF,
          TRANSPORT T, MUNICIPIO MT,
          TIPOOPERAC O,  SERIENF S, SERIEENTR SE
    WHERE (N.CDFILIAL = :CDFILIAL) AND
          (N.NRLANCTONF = :NRLANCTONF) AND
          (N.NRORG = :NRORG) AND
          (N.IDORIGDESTNF = 'L') AND
          (N.CDFILIAL = F.CDFILIAL) AND
          (N.NRORG    = F.NRORG)    AND
          (N.CDEMPRESA = E.CDEMPRESA) AND
          (N.NRORG     = E.NRORG)     AND
          (E.CDPAIS = EM.CDPAIS(+)) AND
          (E.SGESTADO = EM.SGESTADO(+)) AND
          (E.CDPAIS = ME.CDPAIS(+)) AND
          (E.SGESTADO = ME.SGESTADO(+)) AND
          (E.CDMUNICIPIO = ME.CDMUNICIPIO(+)) AND
          (I.CDEMPRESA = E.CDEMPRESA) AND
          (I.NRORG     = E.NRORG)     AND
          (N.CDINSCESTA = I.CDINSCESTA) AND
          (N.NRORG      = I.NRORG)      AND
          (I.CDPAIS = PE.CDPAIS(+)) AND
          (I.CDPAIS = ESE.CDPAIS(+)) AND
          (I.SGESTADO = ESE.SGESTADO(+)) AND
          (I.CDPAIS = MI.CDPAIS(+)) AND
          (I.SGESTADO = MI.SGESTADO(+)) AND
          (I.CDMUNICIPIO = MI.CDMUNICIPIO(+)) AND
          (N.CDFILIEMIT = FR.CDFILIAL(+)) AND
          (N.NRORG      = FR.NRORG(+))    AND
          (FR.IDENDEMISFIL IS NULL) and
          (IR.CDEMPRESA  = FR.CDEMPRESA) and
          (IR.CDINSCESTA = FR.CDINSCESTA) and
          (IR.NRORG      = FR.NRORG)      AND
          (IR.CDPAIS = PC.CDPAIS(+)) AND
          (IR.CDPAIS = ESC.CDPAIS(+)) AND
          (IR.SGESTADO = ESC.SGESTADO(+)) AND
          (IR.CDPAIS = MEC.CDPAIS(+)) and
          (IR.SGESTADO = MEC.SGESTADO(+)) and
          (IR.CDMUNICIPIO = MEC.CDMUNICIPIO(+)) and
          (FR.CDFILIAL = EF.CDFILIAL(+)) AND
          (FR.NRORG    = EF.NRORG(+))    AND
          (EF.IDTPENDEFILI = 'P') AND
          (N.IDTPIJURTRAN = T.IDTPIJURTRAN(+)) AND
          (N.NRINSJURTRAN = T.NRINSJURTRAN(+)) AND
          (N.NRORG        = T.NRORG(+))        AND
          (T.CDPAIS = MT.CDPAIS(+)) AND
          (T.SGESTADO = MT.SGESTADO(+)) AND
          (T.CDMUNICIPIO = MT.CDMUNICIPIO(+)) AND
          (N.CDTIPOOPER = O.CDTIPOOPER(+)) AND
          (N.IDENTRSAIDOP = O.IDENTRSAIDOP(+)) AND
          (N.NRORG        = O.NRORG(+))        AND
          (N.CDEMPRESA = S.CDEMPRESA(+)) AND
          (N.CDINSCESTA = S.CDINSCESTA(+)) AND
          (N.CDINSCMUNI = S.CDINSCMUNI(+)) AND
          (N.CDSERIE = S.CDSERIE(+)) AND
          (N.NRORG   = S.NRORG(+))   AND
          (N.NRORG       = SE.NRORG(+)) AND
          (N.CDSERIEENTR = SE.CDSERIEENTR(+))
    ORDER BY 1,3

SQL;

            $params = array(
                "CDFILIAL" => $cdfilial,
                "NRLANCTONF" => $nrlanctonf,
                "NRORG" => $nrorg
            );
            return \Setforms2\Shared\Connection::getInstance()->fetchAll($sql, $params);
        }catch(\Exception $e){
            throw $e;
        }
    }

    public function consultaCorpoNFCliente($cdfilial ,$nrlanctonf, $nrorg)
    {
        try{
            $sql = <<<SQL
    SELECT N.NRORG,N.CDFILIAL, F.NMFILIAL, N.NRLANCTONF, N.NRNOTAFISCALELE, N.CDEMPRESA, E.CDCNAE, I.NMREPRINSEST,
           E.NMRAZSOCEMPR AS  NMRAZSOCEMIT, I.NRINSJURIEST AS NRINSJUREMIT, I.IDTPIJURIEST AS IDTPIJUREMIT, (I.SGESTADO) AS SGESTAEMIT, (ESE.CDESTADOIBGE) AS CDESTAIBGEEMIT,
           (MI.NMMUNICIPIO) AS NMMUNIEMIT, (MI.CDMUNICIBGE) AS CDMUNIIBGEEMIT, I.DSENDEIEST AS DSENDEEMIT,
           I.NMBAIRIEST AS NMBAIREMIT, I.NRCEPIEST AS NRCEPEMIT, I.NRTELEIEST AS NRTELEEMIT, I.NRFAXIEST AS NRFAXEMIT, N.CDINSCESTA AS NRINSCESTEMIT,
           ' ' AS DSCOMPENDEMIT, PE.CDPAIS AS CDPAISEMIT, PE.CDPAISBACEN AS CDPAISBACENEMIT, PE.NMPAIS AS NMPAISEMIT,
           C.NMRAZSOCCLIE, N.NRINSJURNF AS NRINSJURCLIE, N.IDTPIJURNF AS IDTPIJURCLIE, (EC.SGESTADO) AS SGESTACLIE,  ESC.CDESTADOIBGE AS CDESTAIBGECLIE,
           (MEC.NMMUNICIPIO) AS NMMUNICLIE, (MEC.CDMUNICIBGE) AS CDMUNIIBGECLIE, EC.DSENDECLIE,
           EC.NMBAIRCLIE, EC.NRCEPCLIE, EC.NRTELECLIE, EC.NRFAXCLIE, C.NRINSESTCLIE AS NRINSCESTCLIE,
           EC.DSCOMPENDCLI, PC.CDPAIS AS CDPAISCLIE, PC.CDPAISBACEN AS CDPAISBACENCLIE,  PC.NMPAIS AS NMPAISCLIE,
           N.NRNOTAFISC, NVL(N.DTEMISSAO, N.DTENTRSAID) DTEMISSAO, N.DTENTRSAID,
           DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(VRPRODUTOS, 2), '9999999999999.99')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(VRPRODUTOS, 2), '9999999999999.99')), LTRIM(TO_CHAR(ROUND(VRPRODUTOS, 2), '9999999999999.99'))) AS VRPRODUTOS,
           DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(VRNOTAFISC, 2), '9999999999999.99')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(VRNOTAFISC, 2), '9999999999999.99')), LTRIM(TO_CHAR(ROUND(VRNOTAFISC, 2), '9999999999999.99'))) AS VRNOTAFISC,
           N.NRPLACAVEIC, N.SGUFVEIC, N.IDPGTOFRETE,
           N.DSQTDEVOLU, N.DSESPECVOLU, N.DSMARCAVOLU, N.DSNUMEVOLU,
           DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(VRPLIQUVOLU, 3), '999999999999.999')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(VRPLIQUVOLU, 3), '999999999999.999')), LTRIM(TO_CHAR(ROUND(VRPLIQUVOLU, 3), '999999999999.999'))) AS VRPLIQUVOLU,
           DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(VRPBRUTOVOLU, 3), '999999999999.999')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(VRPBRUTOVOLU, 3), '999999999999.999')), LTRIM(TO_CHAR(ROUND(VRPBRUTOVOLU, 3), '999999999999.999'))) AS VRPBRUTOVOLU,
           I.NRSERIECERTIFIC, NVL(N.IDORIGDESTNF, 'C') IDORIGDESTNF, N.CDCLIENTE, '' AS CDFORNECED, '' AS CDFILIRECE,
           N.IDENTRSAIDOP, N.CDTIPOOPER, N.NRACESSONFE,
           NVL(N.DSCFOPINFUSU, N.DSCDFISOPENF) AS NMTIPOOPER,  O.IDOPERDEVONF, I.IDTPIMPRESDANFE,
           NVL(S.CDSERIENFE, SE.CDSERIEENTRNFE) AS CDSERIE,
           S.DSSERIE AS DSSERIE, N.NRINSJURTRAN,
           N.IDTPIJURTRAN, T.NMRAZSOCTRAN, T.NRINSESTTRAN,
           (T.SGESTADO) AS SGESTATRAN, (MT.NMMUNICIPIO) AS NMMUNITRAN,
           T.DSENDETRAN, NVL(N.CDCFOPINFUSU, N.CDFISOPENTF) AS CDFISOPENTF, NVL(N.DSCFOPINFUSU, N.DSCDFISOPENF) AS DSCDFISOPENF, N.CDINSCMUNI,
           N.CDMODDOCFISC, N.IDTIPOEMISNFE,
           C.NRINSCSUFRAMACL AS NRINSCSUFRAMA,
           C.NMFANTCLIE AS NMFANT, EM.CDESTADOIBGE AS CDESTADOIBGEEMP,
           ME.CDMUNICIBGE AS CDMUNICIBGEEMP,
           E.SGESTADO AS SGESTADOEMP, N.CDINSCESTAST, EC.DSEMAILCLIENFE AS DSEMAILDEST, DTHRPROTOCOLNFE,
           NRREGDPECNFE, DTHRREGCONTNFE, CDBARRACONTING, IDBRINDETPOPER,
           NVL(S.CDSERIENFESCAN, SE.CDSERIEENTSCAN) AS CDSERIESCAN, NVL(O.IDNFESTCANC, 'N') IDNFESTCANC, NVL(O.IDNFAJUSTE, 'N') IDNFAJUSTE,
           N.IDSTATUS
    FROM  NOTAFISCAL N, TRANSPORT T, CLIENTE C,
          ENDECLIE EC, FILIAL F, INSCRESTAD I,
          MUNICIPIO MI, MUNICIPIO MT, MUNICIPIO MEC, MUNICIPIO ME,
          TIPOOPERAC O, EMPRESA E, SERIENF S,
          ESTADO ESE, ESTADO ESC, ESTADO EM,
          PAIS PE, PAIS PC, SERIEENTR SE
    WHERE (N.CDFILIEMIT = :CDFILIAL) AND
          (N.NRLANCTONF = :NRLANCTONF) AND
          (N.NRORG = :NRORG) AND
          (N.CDCLIENTE = C.CDCLIENTE(+)) AND
          (N.NRORG     = C.NRORG(+))     AND
          (C.CDCLIENTE = EC.CDCLIENTE(+)) AND
          (C.NRORG     = EC.NRORG(+))     AND
          (EC.IDTPENDECLIE = NVL(C.IDENDEMISCLI,'P')) AND
          ((N.IDORIGDESTNF IS NULL) OR (N.IDORIGDESTNF = 'C')) AND
          (N.IDTPIJURTRAN = T.IDTPIJURTRAN(+)) AND
          (N.NRINSJURTRAN = T.NRINSJURTRAN(+)) AND
          (N.NRORG        = T.NRORG(+))        AND
          (N.CDFILIAL = F.CDFILIAL) AND
          (N.NRORG    = F.NRORG)    AND
          (N.CDEMPRESA = E.CDEMPRESA) AND
          (N.NRORG     = E.NRORG)     AND
          (I.CDEMPRESA = E.CDEMPRESA) AND
          (I.NRORG     = E.NRORG)     AND
          (N.CDINSCESTA = I.CDINSCESTA) AND
          (N.NRORG      = I.NRORG)      AND
          (E.CDPAIS = EM.CDPAIS(+)) AND
          (E.SGESTADO = EM.SGESTADO(+)) AND
          (E.CDPAIS = ME.CDPAIS(+)) AND
          (E.SGESTADO = ME.SGESTADO(+)) AND
          (E.CDMUNICIPIO = ME.CDMUNICIPIO(+)) AND
          (I.CDPAIS = PE.CDPAIS(+)) AND
          (I.CDPAIS = ESE.CDPAIS(+)) AND
          (I.SGESTADO = ESE.SGESTADO(+)) AND
          (I.CDPAIS = MI.CDPAIS(+)) AND
          (I.SGESTADO = MI.SGESTADO(+)) AND
          (I.CDMUNICIPIO = MI.CDMUNICIPIO(+)) AND
          (EC.CDPAIS = PC.CDPAIS(+)) AND
          (EC.CDPAIS = ESC.CDPAIS(+)) AND
          (EC.SGESTADO = ESC.SGESTADO(+)) AND
          (EC.CDPAIS = MEC.CDPAIS(+)) AND
          (EC.SGESTADO = MEC.SGESTADO(+)) AND
          (EC.CDMUNICIPIO = MEC.CDMUNICIPIO(+)) AND
          (T.CDPAIS = MT.CDPAIS(+)) AND
          (T.SGESTADO = MT.SGESTADO(+)) AND
          (T.CDMUNICIPIO = MT.CDMUNICIPIO(+)) AND
          (N.CDTIPOOPER = O.CDTIPOOPER(+)) AND
          (N.IDENTRSAIDOP = O.IDENTRSAIDOP(+)) AND
          (N.NRORG        = O.NRORG(+))        AND
          (N.CDEMPRESA = S.CDEMPRESA(+)) AND
          (N.CDINSCESTA = S.CDINSCESTA(+)) AND
          (N.CDINSCMUNI = S.CDINSCMUNI(+)) AND
          (N.CDSERIE = S.CDSERIE(+)) AND
          (N.NRORG   = S.NRORG(+))   AND
          (N.NRORG       = SE.NRORG(+)) AND
          (N.CDSERIEENTR = SE.CDSERIEENTR(+))
    ORDER BY CDFILIAL, NRLANCTONF

SQL;

            $params = array(
                "CDFILIAL" => $cdfilial,
                "NRLANCTONF" => $nrlanctonf,
                "NRORG" => $nrorg
            );
            return \Setforms2\Shared\Connection::getInstance()->fetchAll($sql, $params);
        }catch(\Exception $e){
            throw $e;
        }
    }

    public function consultaCorpoNFClienteEntrada($cdfilial ,$nrlanctonf, $nrorg)
    {
        try{
            $sql = <<<SQL
    SELECT N.NRORG,N.CDFILIAL, F.NMFILIAL, N.NRLANCTONF, N.NRNOTAFISCALELE, N.CDEMPRESA, E.CDCNAE, I.NMREPRINSEST,
           E.NMRAZSOCEMPR AS  NMRAZSOCEMIT, I.NRINSJURIEST AS NRINSJUREMIT, I.IDTPIJURIEST AS IDTPIJUREMIT, (I.SGESTADO) AS SGESTAEMIT, (ESE.CDESTADOIBGE) AS CDESTAIBGEEMIT,
           (MI.NMMUNICIPIO) AS NMMUNIEMIT, (MI.CDMUNICIBGE) AS CDMUNIIBGEEMIT, I.DSENDEIEST AS DSENDEEMIT,
           I.NMBAIRIEST AS NMBAIREMIT, I.NRCEPIEST AS NRCEPEMIT, I.NRTELEIEST AS NRTELEEMIT, I.NRFAXIEST AS NRFAXEMIT, N.CDINSCESTA AS NRINSCESTEMIT,
           ' ' AS DSCOMPENDEMIT, PE.CDPAIS AS CDPAISEMIT, PE.CDPAISBACEN AS CDPAISBACENEMIT, PE.NMPAIS AS NMPAISEMIT,
           C.NMRAZSOCCLIE, N.NRINSJURNF AS NRINSJURCLIE, N.IDTPIJURNF AS IDTPIJURCLIE, (EC.SGESTADO) AS SGESTACLIE,  ESC.CDESTADOIBGE AS CDESTAIBGECLIE,
           (MEC.NMMUNICIPIO) AS NMMUNICLIE, (MEC.CDMUNICIBGE) AS CDMUNIIBGECLIE, EC.DSENDECLIE,
           EC.NMBAIRCLIE, EC.NRCEPCLIE, EC.NRTELECLIE, EC.NRFAXCLIE, C.NRINSESTCLIE AS NRINSCESTCLIE,
           EC.DSCOMPENDCLI, PC.CDPAIS AS CDPAISCLIE, PC.CDPAISBACEN AS CDPAISBACENCLIE,  PC.NMPAIS AS NMPAISCLIE,
           N.NRNOTAFISC, NVL(N.DTEMISSAO, N.DTENTRSAID) DTEMISSAO, N.DTENTRSAID,
           DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(VRPRODUTOS, 2), '9999999999999.99')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(VRPRODUTOS, 2), '9999999999999.99')), LTRIM(TO_CHAR(ROUND(VRPRODUTOS, 2), '9999999999999.99'))) AS VRPRODUTOS,
           DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(VRNOTAFISC, 2), '9999999999999.99')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(VRNOTAFISC, 2), '9999999999999.99')), LTRIM(TO_CHAR(ROUND(VRNOTAFISC, 2), '9999999999999.99'))) AS VRNOTAFISC,
           N.NRPLACAVEIC, N.SGUFVEIC, N.IDPGTOFRETE,
           N.DSQTDEVOLU, N.DSESPECVOLU, N.DSMARCAVOLU, N.DSNUMEVOLU,
           DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(VRPLIQUVOLU, 3), '999999999999.999')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(VRPLIQUVOLU, 3), '999999999999.999')), LTRIM(TO_CHAR(ROUND(VRPLIQUVOLU, 3), '999999999999.999'))) AS VRPLIQUVOLU,
           DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(VRPBRUTOVOLU, 3), '999999999999.999')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(VRPBRUTOVOLU, 3), '999999999999.999')), LTRIM(TO_CHAR(ROUND(VRPBRUTOVOLU, 3), '999999999999.999'))) AS VRPBRUTOVOLU,
           I.NRSERIECERTIFIC, NVL(N.IDORIGDESTNF, 'C') IDORIGDESTNF, N.CDCLIENTE, '' AS CDFORNECED, '' AS CDFILIRECE,
           N.IDENTRSAIDOP, N.CDTIPOOPER, N.NRACESSONFE,
           NVL(N.DSCFOPINFUSU, N.DSCDFISOPENF) AS NMTIPOOPER,  O.IDOPERDEVONF, I.IDTPIMPRESDANFE,
           NVL(S.CDSERIENFE, SE.CDSERIEENTRNFE) AS CDSERIE,
           S.DSSERIE AS DSSERIE, N.NRINSJURTRAN,
           N.IDTPIJURTRAN, T.NMRAZSOCTRAN, T.NRINSESTTRAN,
           (T.SGESTADO) AS SGESTATRAN, (MT.NMMUNICIPIO) AS NMMUNITRAN,
           T.DSENDETRAN, NVL(N.CDCFOPINFUSU, N.CDFISOPENTF) AS CDFISOPENTF, NVL(N.DSCFOPINFUSU, N.DSCDFISOPENF) AS DSCDFISOPENF, N.CDINSCMUNI,
           N.CDMODDOCFISC, N.IDTIPOEMISNFE,
           C.NRINSCSUFRAMACL AS NRINSCSUFRAMA,
           C.NMFANTCLIE AS NMFANT, EM.CDESTADOIBGE AS CDESTADOIBGEEMP,
           ME.CDMUNICIBGE AS CDMUNICIBGEEMP,
           E.SGESTADO AS SGESTADOEMP, N.CDINSCESTAST, EC.DSEMAILCLIENFE AS DSEMAILDEST, DTHRPROTOCOLNFE,
           NRREGDPECNFE, DTHRREGCONTNFE, CDBARRACONTING, IDBRINDETPOPER,
           NVL(S.CDSERIENFESCAN, SE.CDSERIEENTSCAN) AS CDSERIESCAN, NVL(O.IDNFESTCANC, 'N') IDNFESTCANC, NVL(O.IDNFAJUSTE, 'N') IDNFAJUSTE,
           N.IDSTATUS
    FROM  NOTAFISCAL N, TRANSPORT T, CLIENTE C,
          ENDECLIE EC, FILIAL F, INSCRESTAD I,
          MUNICIPIO MI, MUNICIPIO MT, MUNICIPIO MEC, MUNICIPIO ME,
          TIPOOPERAC O, EMPRESA E, SERIENF S,
          ESTADO ESE, ESTADO ESC, ESTADO EM,
          PAIS PE, PAIS PC, SERIEENTR SE
    WHERE (N.CDFILIRECE = :CDFILIAL) AND
          (N.NRLANCTONF = :NRLANCTONF) AND
          (N.NRORG = :NRORG) AND
          (N.CDCLIENTE = C.CDCLIENTE(+)) AND
          (N.NRORG     = C.NRORG(+))     AND
          (C.CDCLIENTE = EC.CDCLIENTE(+)) AND
          (C.NRORG     = EC.NRORG(+))     AND
          (EC.IDTPENDECLIE = NVL(C.IDENDEMISCLI,'P')) AND
          ((N.IDORIGDESTNF IS NULL) OR (N.IDORIGDESTNF = 'C')) AND
          (N.IDTPIJURTRAN = T.IDTPIJURTRAN(+)) AND
          (N.NRINSJURTRAN = T.NRINSJURTRAN(+)) AND
          (N.NRORG        = T.NRORG(+))        AND
          (N.CDFILIAL = F.CDFILIAL) AND
          (N.NRORG    = F.NRORG)    AND
          (N.CDEMPRESA = E.CDEMPRESA) AND
          (N.NRORG     = E.NRORG)     AND
          (I.CDEMPRESA = E.CDEMPRESA) AND
          (I.NRORG     = E.NRORG)     AND
          (N.CDINSCESTA = I.CDINSCESTA) AND
          (N.NRORG      = I.NRORG)      AND
          (E.CDPAIS = EM.CDPAIS(+)) AND
          (E.SGESTADO = EM.SGESTADO(+)) AND
          (E.CDPAIS = ME.CDPAIS(+)) AND
          (E.SGESTADO = ME.SGESTADO(+)) AND
          (E.CDMUNICIPIO = ME.CDMUNICIPIO(+)) AND
          (I.CDPAIS = PE.CDPAIS(+)) AND
          (I.CDPAIS = ESE.CDPAIS(+)) AND
          (I.SGESTADO = ESE.SGESTADO(+)) AND
          (I.CDPAIS = MI.CDPAIS(+)) AND
          (I.SGESTADO = MI.SGESTADO(+)) AND
          (I.CDMUNICIPIO = MI.CDMUNICIPIO(+)) AND
          (EC.CDPAIS = PC.CDPAIS(+)) AND
          (EC.CDPAIS = ESC.CDPAIS(+)) AND
          (EC.SGESTADO = ESC.SGESTADO(+)) AND
          (EC.CDPAIS = MEC.CDPAIS(+)) AND
          (EC.SGESTADO = MEC.SGESTADO(+)) AND
          (EC.CDMUNICIPIO = MEC.CDMUNICIPIO(+)) AND
          (T.CDPAIS = MT.CDPAIS(+)) AND
          (T.SGESTADO = MT.SGESTADO(+)) AND
          (T.CDMUNICIPIO = MT.CDMUNICIPIO(+)) AND
          (N.CDTIPOOPER = O.CDTIPOOPER(+)) AND
          (N.IDENTRSAIDOP = O.IDENTRSAIDOP(+)) AND
          (N.NRORG        = O.NRORG(+))        AND
          (N.CDEMPRESA = S.CDEMPRESA(+)) AND
          (N.CDINSCESTA = S.CDINSCESTA(+)) AND
          (N.CDINSCMUNI = S.CDINSCMUNI(+)) AND
          (N.CDSERIE = S.CDSERIE(+)) AND
          (N.NRORG   = S.NRORG(+))   AND
          (N.NRORG       = SE.NRORG(+)) AND
          (N.CDSERIEENTR = SE.CDSERIEENTR(+))
    ORDER BY CDFILIAL, NRLANCTONF

SQL;

            $params = array(
                "CDFILIAL" => $cdfilial,
                "NRLANCTONF" => $nrlanctonf,
                "NRORG" => $nrorg
            );
            return \Setforms2\Shared\Connection::getInstance()->fetchAll($sql, $params);
        }catch(\Exception $e){
            throw $e;
        }
    }

    public function consultaBloqueiaNotaFiscal($cdfilial, $nrlanctonf, $nrorg)
    {
        $sql = <<<SQL
    SELECT CDFILIAL
    FROM NOTAFISCAL
    WHERE CDFILIAL   = :CDFILIAL   AND
          NRLANCTONF = :NRLANCTONF AND
          NRORG = :NRORG
    FOR UPDATE NOWAIT
SQL;
        try{

            $params = array(
                "CDFILIAL" => $cdfilial,
                "NRLANCTONF" => $nrlanctonf,
                "NRORG" => $nrorg
            );
            return \Setforms2\Shared\Connection::getInstance()->fetchAll($sql, $params);
        }catch(\Exception $e){
            throw $e;
        }
    }

    public function consisteFiscal($cdfilial, $nrlanctonf, $nrorg)
    {
        $sql = <<<SQL
    SELECT CDIMPOSTO, NRSEQITPROD, NRSEQCONSISTE, DSCONSISTENCIA, CDARVPROD, NMPRODUTO,
       CDREGRAIT
  FROM TABLE(CONSISTE_FISCAL(:P_CDFILIAL, :P_NRLANCTONF))
SQL;
        try{

            $params = array(
                "P_CDFILIAL" => $cdfilial,
                "P_NRLANCTONF" => $nrlanctonf,
                //                "P_NRORG" => $nrorg
            );
            return \Setforms2\Shared\Connection::getInstance()->fetchAll($sql, $params);
        }catch(\Exception $e){
            throw $e;
        }
    }

    public function consultaFilialOrigem($cdfilial, $nrlanctonf, $nrorg)
    {
        $sql = <<<SQL
    SELECT DECODE(IDENTRSAIDOP, 'S', CDFILIEMIT, CDFILIRECE) AS CDFILIORIG
      FROM NOTAFISCAL
     WHERE CDFILIAL   = :CDFILIAL
       AND NRLANCTONF = :NRLANCTONF
       AND NRORG = :NRORG
SQL;
        try{

            $params = array(
                "CDFILIAL" => $cdfilial,
                "NRLANCTONF" => $nrlanctonf,
                "NRORG" => $nrorg
            );
            //            return \Setforms2\Shared\Connection::getInstance()->fetchAll($sql, $params);
            return self::getEntityManager()->getConnection()->fetchAssoc($sql, $params);
        }catch(\Exception $e){
            throw $e;
        }
    }

    /**
     * @param $args
     *           "CDFILIAL"
     *           "IDMODO"
     *           "DATAINICIO"
     *           "DATAFINAL"
     *           "CDTIPOOPER"
     *           "CDEMPRESA"
     *           "INSCMUNI"
     *           "INSCESTA"
     *           "CDSERIE"
     *           "IDSITUACAONF"
     *           "TIPOEMISSAO"
     *           "CLIENTE"
     *           "CDROTATRANS"
     * @return array
     */
    public static function consultaClienteNFE($args)
    {
        $sql = <<<SQL
    SELECT
       NF.NRORG, NF.CDEMPRESA,     NF.CDINSCESTA,    NF.CDINSCMUNI,
       NF.CDSERIE,       NF.NRNOTAFISCALELE, NF.NRLANCTONF,
       NF.CDFILIAL,      NF.CDOPERAPRO,    NF.IDDOCFISCAL,
       NF.IDENTRSAIDOP,  NF.IDDOCFINANC,   NF.CDTIPOOPER,
       NF.IDTPIJURNF,    NF.NRINSJURNF,
       NF.IDSTATUS,      NF.CDFORNECED,    NF.VRNOTAFISC,
       NF.CDCLIENTE,     NF.DTEMISSAO,     NF.CDFILIRECE,
       NF.IDORIGDESTNF,  NF.IDSISTEMA,     NF.NRLICENCAUSO,
       NF.NRAPURACFAT,   T.NMTIPOOPER,     T.CDTPCTRECEB AS CDTPCTRECOP,
       T.IDCONTABOPER,   NF.CDFILIEMIT,
       ('U') AS IDCHECK, NF.DTENTRSAID,
       SUBSTR('Data Saída: '||TO_CHAR(NF.DTENTRSAID)||' Data Emissão: '||TO_CHAR(NF.DTEMISSAO)||' Seq.: '||NF.NRLANCTONF||' ('||T.NMTIPOOPER||')',1,120) AS DTNOTAFISC,
       C.VRPEMORBCLI,    C.VRPEMULBCLI,
       NVL(L.NMRAZSOCLUSO, C.NMRAZSOCCLIE) AS NMRAZSOCCLIE,
       CT.IDAPURACOK, TR.CDCLASSFINA AS CDCLAFINOP, NF.CDSERIE AS CDSERIENUMNF,
       NF.IDUTLIBERANF, NF.IDSTATUSNFE, NF.DSOBSSTATUSNFE,
       NF.CDMODDOCFISC, NF.NRACESSONFE, NF.NRNOTAFISC,
       NF.NRPROTOCOLONFE, NF.IDEMAILNFE, NF.IDTIPOEMISNFE, NF.IDTPAMBNFE,
       TO_CHAR(NF.DTENTRSAID, 'DD/MM/YYYY') DATASAIDA,
       TO_CHAR(NF.DTEMISSAO, 'DD/MM/YYYY') DATAEMISSAO,
       NF.IDEMAILNFETRANSP, NF.NRINSJURTRAN
    FROM  TIPOCTRECEBER TR, LICENCAUSO L, CLIENTE C, CTRLAPURFAT CT,
          (SELECT /*+ INDEX(N NOTAFISCAL_09) */
                 N.NRORG, N.CDEMPRESA,     N.CDINSCESTA,    N.CDINSCMUNI,
                 N.CDSERIE,       N.NRNOTAFISCALELE, N.NRLANCTONF,
                 N.CDFILIAL,      N.CDOPERAPRO,
                 N.IDDOCFISCAL,   N.IDENTRSAIDOP,
                 N.IDDOCFINANC,   N.CDTIPOOPER,     N.IDTPIJURNF,
                 N.NRINSJURNF,    N.IDSTATUS,       N.CDFORNECED,
                 N.NRLANCTBDOC,   N.VRNOTAFISC,     N.IDERROS,
                 N.IDAVISOS,      N.CDCLIENTE,
                 DECODE(NVL(P.IDUTDTPROCTNFE,'N'), 'S', DECODE(TP.IDTPTRANSNFE,'F', N.DTEMISSAO, NVL(N.DTEMISSAO, N.DTENTRSAID)), NVL(N.DTEMISSAO, N.DTENTRSAID)) DTEMISSAO,
                 N.CDFILIRECE,    N.IDORIGDESTNF,   N.IDSISTEMA,
                 N.NRLICENCAUSO,  N.NRAPURACFAT,    N.DTENTRSAID,
                 N.CDFILIEMIT,    N.CDINTEGRACAO,   N.NREXPEDICAO,
                 N.IDSTATUSNFE,   N.CDMODDOCFISC,   N.DSOBSSTATUSNFE,
                 N.NRACESSONFE,   N.NRPROTOCOLONFE, N.NRNOTAFISC,
                 FF.IDUTLIBERANF, N.IDEMAILNFE, N.IDTIPOEMISNFE, N.IDTPAMBNFE, NVL(N.IDEMAILNFETRANSP, 'N') IDEMAILNFETRANSP, N.NRINSJURTRAN
                 FROM NOTAFISCAL N,  PARAMGERAL P, TIPOOPERAC TP,
                     (SELECT F.CDFILIAL, P.IDUTLIBERANF
                       FROM FILIAL F, PARAMFILIAL P
                       WHERE NVL(F.CDFILIFISC, F.CDFILIAL) = NVL(:CDFILIAL, NVL(F.CDFILIFISC, F.CDFILIAL))
                         AND NVL(F.CDFILIFISC, F.CDFILIAL) = P.CDFILIAL
                         AND :IDMODO = 'N'
                      UNION ALL
                      SELECT F.CDFILIAL, P.IDUTLIBERANF
                        FROM FILIAL F, PARAMFILIAL P
                       WHERE F.CDFILIAL = :CDFILIAL
                         AND F.CDFILIAL = P.CDFILIAL
                         AND :IDMODO = 'F') FF
          WHERE N.CDTIPOOPER = TP.CDTIPOOPER                   AND
                N.IDENTRSAIDOP = TP.IDENTRSAIDOP               AND
                N.CDFILIEMIT = FF.CDFILIAL                     AND
                N.IDENTRSAIDOP = 'S'                           AND
                N.DTENTRSAID BETWEEN :DATAINICIO AND :DATAFINAL AND
                NVL(N.IDSISTEMA, 'DFS') <> 'ITG'               AND
                NVL(N.IDSISTEMA, 'DFS') <> 'REC') NF,

         (SELECT IDENTRSAIDOP, CDTIPOOPER, NMTIPOOPER,
                 CDTPCTRECEB, IDCONTABOPER
          FROM TIPOOPERAC
          WHERE IDENTRSAIDOP = 'S'
            AND DECODE(IDTPTRANSNFE, 'C', 'N', IDTPTRANSNFE) = :IDMODO
            AND ((INSTR(:CDTIPOOPER, '_' || IDENTRSAIDOP || CDTIPOOPER || '_') > 0) OR (:CDTIPOOPER = 'T'))) T

    WHERE NF.CDEMPRESA = :CDEMPRESA                                                 AND
          ((NF.CDINSCESTA = :INSCESTA) OR (:INSCESTA = 'T'))                    AND
          ((NF.CDINSCMUNI = :INSCMUNI) OR (:INSCMUNI = 'T'))                    AND
          ((NF.CDSERIE = :CDSERIE) OR (:CDSERIE = 'T'))                             AND
          NF.DTENTRSAID BETWEEN :DATAINICIO AND :DATAFINAL                           AND
          ((INSTR(:IDSITUACAONF, NF.IDSTATUSNFE) <> 0) OR (:IDSITUACAONF = 'T'))  AND
          ((INSTR(:TIPOEMISSAO, NF.IDTIPOEMISNFE) > 0) OR (:TIPOEMISSAO = 'T')) AND
          NF.IDENTRSAIDOP = T.IDENTRSAIDOP                                          AND
          NF.CDTIPOOPER = T.CDTIPOOPER                                              AND
          NVL(NF.IDORIGDESTNF, 'C') = 'C'                                           AND
          (NF.NRINSJURNF = :CLIENTE OR :CLIENTE = 'T')                          AND
          T.CDTPCTRECEB = TR.CDTPCTRECEB(+)                                         AND
          NF.CDCLIENTE = C.CDCLIENTE                                                AND
          NF.CDCLIENTE = L.CDCLIENTE(+)                                             AND
          NF.NRLICENCAUSO = L.NRLICENCAUSO(+)                                       AND
          NF.CDFILIAL = CT.CDFILIAL(+)                                              AND
          NF.NRAPURACFAT = CT.NRAPURACFAT(+)                                        AND
          ((:CDROTATRANS = 'T') OR (EXISTS(SELECT 1
                                                FROM FILIALROTA
                                               WHERE FILIALROTA.CDFILIROTA = NF.CDFILIRECE
                                                 AND INSTR(:CDROTATRANS, '_' || CDROTATRANS || '_') > 0)))
    ORDER BY 1, 2, 3, 4, 5, 6

SQL;
        $params = array(
            "CDFILIAL"   => $args["cdfilial"],
            "IDMODO"     => $args["idmodo"],
            "DATAINICIO" => $args["datainicio"],
            "DATAFINAL"  => $args["datafinal"],
            "CDTIPOOPER"  => $args["cdtipooper"],
            "CDEMPRESA"  => $args["cdempresa"],
            "INSCMUNI"  => $args["inscmuni"],
            "INSCESTA"  => $args["inscesta"],
            "CDSERIE"  => $args["cdserie"],
            "IDSITUACAONF"  => $args["idsituacaonf"],
            "TIPOEMISSAO"  => $args["tipoemissao"],
            "CLIENTE"  => $args["cliente"],
            "CDROTATRANS"  => $args["cdrotatrans"]
        );

        return \Setforms2\Shared\Connection::getInstance()->fetchAll($sql, $params);
    }

    /**
     * @param $args
     *           "CDFILIAL"
     *           "IDMODO"
     *           "DATAINICIO"
     *           "DATAFINAL"
     *           "CDTIPOOPER"
     *           "CDEMPRESA"
     *           "INSCMUNI"
     *           "INSCESTA"
     *           "CDSERIE"
     *           "IDSITUACAONF"
     *           "TIPOEMISSAO"
     *           "CLIENTE"
     *           "CDROTATRANS"
     * @return array
     */
    public static function consultaFornecedorNFE($args)
    {
        $sql = <<<SQL
    SELECT NF.NRORG, NF.CDEMPRESA,     NF.CDINSCESTA,    NF.CDINSCMUNI,
           NF.CDSERIE,       NF.NRNOTAFISCALELE, NF.NRLANCTONF,
           NF.CDFILIAL,      NF.IDBLOQUEADO,   NF.CDOPERAPRO,
           NF.IDDOCFISCAL,   NF.IDENTRSAIDOP,
           NF.IDDOCFINANC,   NF.CDTIPOOPER,   NF.IDTPIJURNF,
           NF.NRINSJURNF,
           NF.IDSTATUS,      NF.CDFORNECED,
           NF.NRLANCTBDOC,   NF.VRNOTAFISC,    NF.IDERROS,
           NF.IDAVISOS,      NF.CDCLIENTE,     NF.DTEMISSAO,
           NF.CDFILIRECE,    NF.IDORIGDESTNF,  NF.IDSISTEMA,
           NF.NRLICENCAUSO,  NF.NRAPURACFAT,   T.NMTIPOOPER,
           T.CDTPCTRECEB AS CDTPCTRECOP,  T.IDCONTABOPER,
           ' ' AS IDERROAVISO, NF.CDFILIEMIT,
           ('U') AS IDCHECK, NF.DTENTRSAID,
           SUBSTR('Data Saída: '||TO_CHAR(NF.DTENTRSAID)||' Data Emissão: '||TO_CHAR(NF.DTEMISSAO)||' Seq.: '||NF.NRLANCTONF||' ('||T.NMTIPOOPER||')',1,120) AS DTNOTAFISC,
           0.0 AS VRPEMORBCLI,  0.0 AS VRPEMULBCLI,
           F.NMRAZSOCFORN AS NMRAZSOCCLIE,
           'S' AS IDAPURACOK, CAST('' AS VARCHAR2(10))  NRAPURACFAT,
           TR.CDCLASSFINA AS CDCLAFINOP,
           NF.CDSERIE AS CDSERIENUMNF,
           NF.IDUTLIBERANF, NF.CDINTEGRACAO, NF.IDSTATUSNFE,
           NF.DSOBSSTATUSNFE, NF.CDMODDOCFISC,
           NF.NRACESSONFE, NF.NRPROTOCOLONFE, NF.NRNOTAFISC, NF.IDEMAILNFE,
           NF.IDTIPOEMISNFE, NF.IDTPAMBNFE,
           TO_CHAR(NF.DTENTRSAID, 'DD/MM/YYYY') DATASAIDA,
           TO_CHAR(NF.DTEMISSAO, 'DD/MM/YYYY') DATAEMISSAO,
           NF.IDEMAILNFETRANSP, NF.NRINSJURTRAN
    FROM TIPOCTRECEBER TR, FORNECEDOR F,

         (SELECT /*+ INDEX(N NOTAFISCAL_09) */
                 N.NRORG, N.CDEMPRESA,     N.CDINSCESTA,    N.CDINSCMUNI,
                 N.CDSERIE,       N.NRNOTAFISCALELE, N.NRLANCTONF,
                 N.CDFILIAL,      N.IDBLOQUEADO,   N.CDOPERAPRO,
                 N.IDDOCFISCAL,   N.IDENTRSAIDOP,
                 N.IDDOCFINANC,   N.CDTIPOOPER,    N.IDTPIJURNF,
                 N.NRINSJURNF,    N.IDSTATUS,      N.CDFORNECED,
                 N.NRLANCTBDOC,   N.VRNOTAFISC,    N.IDERROS,
                 N.IDAVISOS,      N.CDCLIENTE,     N.DTENTRSAID,
                 N.CDFILIRECE,    N.IDORIGDESTNF,  N.IDSISTEMA,
                 N.NRLICENCAUSO,  N.NRAPURACFAT,
                 DECODE(NVL(P.IDUTDTPROCTNFE,'N'), 'S', DECODE(TP.IDTPTRANSNFE,'F', N.DTEMISSAO, NVL(N.DTEMISSAO, N.DTENTRSAID)), NVL(N.DTEMISSAO, N.DTENTRSAID)) DTEMISSAO,
                 N.CDFILIEMIT,    N.CDINTEGRACAO,  N.NREXPEDICAO,
                 N.IDSTATUSNFE,   N.CDMODDOCFISC,  N.DSOBSSTATUSNFE,
                 N.NRACESSONFE,   N.NRPROTOCOLONFE, N.NRNOTAFISC,
                 FF.IDUTLIBERANF, N.IDEMAILNFE, N.IDTIPOEMISNFE, N.IDTPAMBNFE, NVL(N.IDEMAILNFETRANSP, 'N') IDEMAILNFETRANSP, N.NRINSJURTRAN
                 FROM NOTAFISCAL N, PARAMGERAL P, TIPOOPERAC TP,
                     (SELECT F.CDFILIAL, P.IDUTLIBERANF
                       FROM FILIAL F, PARAMFILIAL P
                       WHERE NVL(F.CDFILIFISC, F.CDFILIAL) = NVL(:CDFILIAL, NVL(F.CDFILIFISC, F.CDFILIAL))
                         AND NVL(F.CDFILIFISC, F.CDFILIAL) = P.CDFILIAL
                         AND :IDMODO = 'N'
                      UNION ALL
                      SELECT F.CDFILIAL, P.IDUTLIBERANF
                        FROM FILIAL F, PARAMFILIAL P
                       WHERE F.CDFILIAL = :CDFILIAL
                         AND F.CDFILIAL = P.CDFILIAL
                         AND :IDMODO = 'F') FF
          WHERE N.CDTIPOOPER = TP.CDTIPOOPER                   AND
                N.IDENTRSAIDOP = TP.IDENTRSAIDOP               AND
                N.CDFILIEMIT = FF.CDFILIAL                     AND
                N.IDENTRSAIDOP = 'S'                           AND
                N.DTENTRSAID BETWEEN :DATAINICIO AND :DATAFINAL AND
                NVL(N.IDSISTEMA, 'DFS') <> 'ITG'               AND
                NVL(N.IDSISTEMA, 'DFS') <> 'REC') NF,

         (SELECT IDENTRSAIDOP, CDTIPOOPER, NMTIPOOPER,
                 CDTPCTRECEB, IDCONTABOPER
          FROM TIPOOPERAC
          WHERE IDENTRSAIDOP = 'S'
            AND DECODE(IDTPTRANSNFE, 'C' , 'N', IDTPTRANSNFE) = :IDMODO
            AND ((INSTR(:CDTIPOOPER, '_' || IDENTRSAIDOP || CDTIPOOPER || '_') > 0) OR (:CDTIPOOPER = 'T'))) T

    WHERE NF.CDEMPRESA = :CDEMPRESA                                                 AND
          ((NF.CDINSCESTA = :INSCESTA) OR (:INSCESTA = 'T'))                    AND
          ((NF.CDINSCMUNI = :INSCMUNI) OR (:INSCMUNI = 'T'))                    AND
          ((NF.CDSERIE = :CDSERIE) OR (:CDSERIE = 'T'))                             AND
          NF.IDENTRSAIDOP = T.IDENTRSAIDOP                                          AND
          NF.CDTIPOOPER = T.CDTIPOOPER                                              AND
          NVL(NF.IDORIGDESTNF, 'F') = 'F'                                           AND
          ((INSTR(:IDSITUACAONF, NF.IDSTATUSNFE) <> 0) OR (:IDSITUACAONF = 'T'))  AND
          ((INSTR(:TIPOEMISSAO, NF.IDTIPOEMISNFE) > 0) OR (:TIPOEMISSAO = 'T')) AND
          (NF.NRINSJURNF = :CLIENTE OR :CLIENTE = 'T')                          AND
          T.CDTPCTRECEB = TR.CDTPCTRECEB(+)                                         AND
          NF.CDFORNECED = F.CDFORNECED                                              AND
          ((:CDROTATRANS = 'T') OR (EXISTS(SELECT 1
                                                FROM FILIALROTA
                                               WHERE FILIALROTA.CDFILIROTA = NF.CDFILIRECE
                                                 AND INSTR(:CDROTATRANS, '_' || CDROTATRANS || '_') > 0)))
    ORDER BY 1, 2, 3, 4, 5, 6

SQL;

        $params = array(
            "CDFILIAL"   => $args["cdfilial"],
            "IDMODO"     => $args["idmodo"],
            "DATAINICIO" => $args["datainicio"],
            "DATAFINAL"  => $args["datafinal"],
            "CDTIPOOPER"  => $args["cdtipooper"],
            "CDEMPRESA"  => $args["cdempresa"],
            "INSCMUNI"  => $args["inscmuni"],
            "INSCESTA"  => $args["inscesta"],
            "CDSERIE"  => $args["cdserie"],
            "IDSITUACAONF"  => $args["idsituacaonf"],
            "TIPOEMISSAO"  => $args["tipoemissao"],
            "CLIENTE"  => $args["cliente"],
            "CDROTATRANS"  => $args["cdrotatrans"]
        );

        return \Setforms2\Shared\Connection::getInstance()->fetchAll($sql, $params);
    }

    public static function consultaFilialNFE($args)
    {
        $sql = <<<SQL
    SELECT NF.NRORG, NF.CDEMPRESA,     NF.CDINSCESTA,    NF.CDINSCMUNI,
           NF.CDSERIE,       NF.NRNOTAFISCALELE, NF.NRLANCTONF,
           NF.CDFILIAL,      NF.IDBLOQUEADO,   NF.CDOPERAPRO,
           NF.IDDOCFISCAL,   NF.IDENTRSAIDOP,
           NF.IDDOCFINANC,   NF.CDTIPOOPER,    NF.IDTPIJURNF,
           NF.NRINSJURNF,
           NF.IDSTATUS,      NF.CDFORNECED,
           NF.NRLANCTBDOC,   NF.VRNOTAFISC,    NF.IDERROS,
           NF.IDAVISOS,      NF.CDCLIENTE,     NF.DTEMISSAO,
           NF.CDFILIRECE,    NF.IDORIGDESTNF,  NF.IDSISTEMA,
           NF.NRLICENCAUSO,  NF.NRAPURACFAT,   T.NMTIPOOPER,
           T.CDTPCTRECEB AS CDTPCTRECOP,  T.IDCONTABOPER,
           (' ') AS IDERROAVISO, NF.CDFILIEMIT,
           ('U') AS IDCHECK, NF.DTENTRSAID,
           SUBSTR('Data Saída: '||TO_CHAR(NF.DTENTRSAID)||' Data Emissão: '||TO_CHAR(NF.DTEMISSAO)||' Seq.: '||NF.NRLANCTONF||' ('||T.NMTIPOOPER||')',1,120) AS DTNOTAFISC,
           0.0 AS VRPEMORBCLI,
           0.0 AS VRPEMULBCLI,
           FI.NMFILIAL AS NMRAZSOCCLIE,
           'S' AS IDAPURACOK,  CAST('' AS VARCHAR2(10))  NRAPURACFAT,
           TR.CDCLASSFINA AS CDCLAFINOP,
           NF.CDSERIE AS CDSERIENUMNF,
           NF.IDUTLIBERANF,
           NF.CDINTEGRACAO,
           NF.IDSTATUSNFE, NF.CDMODDOCFISC,
           NF.DSOBSSTATUSNFE,
           NF.NRACESSONFE, NF.NRPROTOCOLONFE,
           NF.NRNOTAFISC, NF.IDEMAILNFE, NF.IDTIPOEMISNFE, NF.IDTPAMBNFE,
           TO_CHAR(NF.DTENTRSAID, 'DD/MM/YYYY') DATASAIDA,
           TO_CHAR(NF.DTEMISSAO, 'DD/MM/YYYY') DATAEMISSAO,
           NF.IDEMAILNFETRANSP, NF.NRINSJURTRAN
    FROM TIPOCTRECEBER TR, FILIAL FI,
         (SELECT /*+ INDEX(N NOTAFISCAL_09) */
                 N.NRORG, N.CDEMPRESA,     N.CDINSCESTA,    N.CDINSCMUNI,
                 N.CDSERIE,       N.NRNOTAFISCALELE, N.NRLANCTONF,
                 N.CDFILIAL,      N.IDBLOQUEADO,   N.CDOPERAPRO,
                 N.IDDOCFISCAL,   N.IDENTRSAIDOP,
                 N.IDDOCFINANC,   N.CDTIPOOPER,    N.IDTPIJURNF,
                 N.NRINSJURNF,    N.IDSTATUS,      N.CDFORNECED,
                 N.NRLANCTBDOC,   N.VRNOTAFISC,    N.IDERROS,
                 N.IDAVISOS,      N.CDCLIENTE,
                 DECODE(NVL(P.IDUTDTPROCTNFE,'N'), 'S', DECODE(TP.IDTPTRANSNFE,'F', N.DTEMISSAO, NVL(N.DTEMISSAO, N.DTENTRSAID)), NVL(N.DTEMISSAO, N.DTENTRSAID)) DTEMISSAO,
                 N.CDFILIRECE,    N.IDORIGDESTNF,  N.IDSISTEMA,
                 N.NRLICENCAUSO,  N.NRAPURACFAT,   N.DTENTRSAID,
                 N.CDFILIEMIT,    N.CDINTEGRACAO,  N.NREXPEDICAO,
                 N.IDSTATUSNFE,   N.CDMODDOCFISC,  N.DSOBSSTATUSNFE,
                 N.NRACESSONFE,   N.NRPROTOCOLONFE, N.NRNOTAFISC,
                 FF.IDUTLIBERANF, N.IDEMAILNFE, N.IDTIPOEMISNFE, N.IDTPAMBNFE, NVL(N.IDEMAILNFETRANSP, 'N') IDEMAILNFETRANSP, N.NRINSJURTRAN
                 FROM NOTAFISCAL N, PARAMGERAL P, TIPOOPERAC TP,
                     (SELECT F.CDFILIAL, P.IDUTLIBERANF
                       FROM FILIAL F, PARAMFILIAL P
                       WHERE NVL(F.CDFILIFISC, F.CDFILIAL) = NVL(:CDFILIAL, NVL(F.CDFILIFISC, F.CDFILIAL))
                         AND NVL(F.CDFILIFISC, F.CDFILIAL) = P.CDFILIAL
                         AND :IDMODO = 'N'
                      UNION ALL
                      SELECT F.CDFILIAL, P.IDUTLIBERANF
                        FROM FILIAL F, PARAMFILIAL P
                       WHERE F.CDFILIAL = :CDFILIAL
                         AND F.CDFILIAL = P.CDFILIAL
                         AND :IDMODO = 'F') FF
          WHERE N.CDTIPOOPER = TP.CDTIPOOPER AND
                N.IDENTRSAIDOP = TP.IDENTRSAIDOP                AND
                N.CDFILIEMIT = FF.CDFILIAL                      AND
                N.IDENTRSAIDOP = 'S'                            AND
                N.DTENTRSAID BETWEEN :DATAINICIO AND :DATAFINAL  AND
                NVL(N.IDSISTEMA, 'DFS') <> 'ITG'                AND
                NVL(N.IDSISTEMA, 'DFS') <> 'REC') NF,

         (SELECT IDENTRSAIDOP, CDTIPOOPER, NMTIPOOPER,
                 CDTPCTRECEB, IDCONTABOPER
          FROM TIPOOPERAC
          WHERE IDENTRSAIDOP = 'S'
            AND DECODE(IDTPTRANSNFE, 'C', 'N', IDTPTRANSNFE) = :IDMODO
            AND ((INSTR(:CDTIPOOPER, '_' || IDENTRSAIDOP || CDTIPOOPER || '_') > 0) OR (:CDTIPOOPER = 'T'))) T

    WHERE NF.CDEMPRESA = :CDEMPRESA                                                 AND
          ((NF.CDINSCESTA = :INSCESTA) OR (:INSCESTA = 'T'))                    AND
          ((NF.CDINSCMUNI = :INSCMUNI) OR (:INSCMUNI = 'T'))                    AND
          ((NF.CDSERIE = :CDSERIE) OR (:CDSERIE = 'T'))                             AND
          NF.IDENTRSAIDOP = T.IDENTRSAIDOP                                          AND
          NF.CDTIPOOPER = T.CDTIPOOPER                                              AND
          (NF.CDFILIRECE = :CDFILIRECE  OR :CDFILIRECE = 'T')                   AND
          (NVL(NF.IDORIGDESTNF, 'L') = 'L')                                         AND
          (NF.NRINSJURNF = :CLIENTE OR :CLIENTE = 'T')                          AND
          ((INSTR(:IDSITUACAONF, NF.IDSTATUSNFE) <> 0) OR (:IDSITUACAONF = 'T'))  AND
          ((INSTR(:TIPOEMISSAO, NF.IDTIPOEMISNFE) > 0) OR (:TIPOEMISSAO = 'T')) AND
          T.CDTPCTRECEB = TR.CDTPCTRECEB(+)                                         AND
          NF.CDFILIRECE = FI.CDFILIAL                                               AND
          ((:CDROTATRANS = 'T') OR (EXISTS(SELECT 1
                                                FROM FILIALROTA
                                               WHERE FILIALROTA.CDFILIROTA = NF.CDFILIRECE
                                                 AND INSTR(:CDROTATRANS, '_' || CDROTATRANS || '_') > 0)))
    ORDER BY 1, 2, 3, 4, 5, 6

SQL;


        $params = array(
            "CDFILIAL"   => $args["cdfilial"],
            "CDFILIRECE"   => $args["cdfilirece"],
            "IDMODO"     => $args["idmodo"],
            "DATAINICIO" => $args["datainicio"],
            "DATAFINAL"  => $args["datafinal"],
            "CDTIPOOPER"  => $args["cdtipooper"],
            "CDEMPRESA"  => $args["cdempresa"],
            "INSCMUNI"  => $args["inscmuni"],
            "INSCESTA"  => $args["inscesta"],
            "CDSERIE"  => $args["cdserie"],
            "IDSITUACAONF"  => $args["idsituacaonf"],
            "TIPOEMISSAO"  => $args["tipoemissao"],
            "CLIENTE"  => $args["cliente"],
            "CDROTATRANS"  => $args["cdrotatrans"]
        );


        $keys = array();
        $values = array();
        foreach($params as $k => $v){
            $keys[] = "/\:".$k."/";
            $values[] = "'$v'";
        }

        $debug = preg_replace($keys, $values, $sql);


        return \Setforms2\Shared\Connection::getInstance()->fetchAll($sql, $params);
    }

    public static function consultaNotaFiscalSaidaNFE($args)
    {
        $sql = <<<SQL
    SELECT
       NF.NRORG, NF.CDEMPRESA, NF.CDINSCESTA, NF.CDINSCMUNI,
       NF.CDSERIE, NF.NRNOTAFISCALELE, NF.NRLANCTONF,
       NF.CDFILIAL, NF.CDOPERAPRO, NF.IDDOCFISCAL,
       NF.IDENTRSAIDOP, NF.IDDOCFINANC, NF.CDTIPOOPER,
       NF.IDTPIJURNF, NF.NRINSJURNF,
       NF.IDSTATUS, NF.CDFORNECED, NF.VRNOTAFISC,
       NF.CDCLIENTE, NF.DTEMISSAO, NF.CDFILIRECE,
       NF.IDORIGDESTNF, NF.IDSISTEMA, NF.NRLICENCAUSO,
       NF.NRAPURACFAT, T.NMTIPOOPER, T.CDTPCTRECEB AS CDTPCTRECOP,
       T.IDCONTABOPER,
       NF.CDFILIEMIT,
       ('U') AS IDCHECK, NF.DTENTRSAID,
       SUBSTR('Data Saída: '||TO_CHAR(NF.DTENTRSAID)||' Data Emissão: '||TO_CHAR(NF.DTEMISSAO)||' Seq.: '||NF.NRLANCTONF||' ('||T.NMTIPOOPER||')',1,120) AS DTNOTAFISC,
       C.VRPEMORBCLI,
       C.VRPEMULBCLI,
       DECODE(NF.IDORIGDESTNF,'U',L.NMFANTLUSO,'C',C.NMRAZSOCCLIE,'F',FO.NMRAZSOCFORN,FI.NMFILIAL)  AS NMRAZSOCCLIE,
       CT.IDAPURACOK, TR.CDCLASSFINA AS CDCLAFINOP,  NF.CDSERIE AS CDSERIENUMNF,
       NF.IDUTLIBERANF, FO.NMRAZSOCFORN, FI.NMFILIAL,
       NF.IDSTATUSNFE, NF.CDMODDOCFISC, NF.DSOBSSTATUSNFE,
       NF.NRACESSONFE, NF.NRPROTOCOLONFE, NF.NRNOTAFISC, NF.IDEMAILNFE,
       NF.IDTIPOEMISNFE, NF.IDTPAMBNFE,
       TO_CHAR(NF.DTENTRSAID, 'DD/MM/YYYY') DATASAIDA,
       TO_CHAR(NF.DTEMISSAO, 'DD/MM/YYYY') DATAEMISSAO,
       NF.IDEMAILNFETRANSP, NF.NRINSJURTRAN
    FROM
         (SELECT /*+ INDEX(N NOTAFISCAL_09) */
                 N.NRORG, N.CDEMPRESA,     N.CDINSCESTA,    N.CDINSCMUNI,
                 N.CDSERIE,       N.NRNOTAFISCALELE, N.NRLANCTONF,
                 N.CDFILIAL,      N.CDOPERAPRO,    N.IDDOCFISCAL,
                 N.IDENTRSAIDOP,  N.IDDOCFINANC,   N.CDTIPOOPER,
                 N.IDTPIJURNF,    N.NRINSJURNF,    N.IDSTATUS,
                 N.CDFORNECED,    N.VRNOTAFISC,    N.CDCLIENTE,
                 DECODE(NVL(P.IDUTDTPROCTNFE,'N'), 'S', DECODE(TP.IDTPTRANSNFE,'F', N.DTEMISSAO, NVL(N.DTEMISSAO, N.DTENTRSAID)), NVL(N.DTEMISSAO, N.DTENTRSAID)) DTEMISSAO,
                 N.CDFILIRECE,    N.IDORIGDESTNF,
                 N.IDSISTEMA,     N.NRLICENCAUSO,  N.NRAPURACFAT,
                 N.DTENTRSAID,    N.CDFILIEMIT,    N.IDSTATUSNFE,
                 FF.IDUTLIBERANF, N.CDMODDOCFISC,   N.DSOBSSTATUSNFE,
                 N.NRACESSONFE,   N.NRPROTOCOLONFE, N.NRNOTAFISC, N.IDEMAILNFE,
                 N.IDTIPOEMISNFE, N.IDTPAMBNFE, NVL(N.IDEMAILNFETRANSP, 'N') IDEMAILNFETRANSP, N.NRINSJURTRAN
                 FROM NOTAFISCAL N, PARAMGERAL P, TIPOOPERAC TP,
                     (SELECT F.CDFILIAL, P.IDUTLIBERANF
                       FROM FILIAL F, PARAMFILIAL P
                       WHERE NVL(F.CDFILIFISC, F.CDFILIAL) = NVL(:CDFILIAL, NVL(F.CDFILIFISC, F.CDFILIAL)) AND
                             NVL(F.CDFILIFISC, F.CDFILIAL) = P.CDFILIAL AND
                             :IDMODO = 'N'
                      UNION ALL
                      SELECT F.CDFILIAL, P.IDUTLIBERANF
                        FROM FILIAL F, PARAMFILIAL P
                       WHERE F.CDFILIAL = :CDFILIAL
                         AND F.CDFILIAL = P.CDFILIAL
                         AND :IDMODO = 'F') FF
          WHERE N.CDTIPOOPER = TP.CDTIPOOPER                   AND
                N.IDENTRSAIDOP = TP.IDENTRSAIDOP               AND
                N.CDFILIEMIT = FF.CDFILIAL                     AND
                N.IDENTRSAIDOP = 'S'                           AND
                N.DTENTRSAID BETWEEN :DATAINICIO AND :DATAFINAL AND
                NVL(N.IDSISTEMA, 'DFS') <> 'ITG'               AND
                NVL(N.IDSISTEMA, 'DFS') <> 'REC') NF,

         TIPOCTRECEBER TR, LICENCAUSO L, CLIENTE C, CTRLAPURFAT CT, FORNECEDOR FO, FILIAL FI,

         (SELECT IDENTRSAIDOP, CDTIPOOPER, NMTIPOOPER,
                 CDTPCTRECEB, IDCONTABOPER, IDDTCONTAB
          FROM TIPOOPERAC
          WHERE IDENTRSAIDOP = 'S'
            AND DECODE(IDTPTRANSNFE, 'C', 'N', IDTPTRANSNFE) = :IDMODO
            AND ((INSTR(:CDTIPOOPER, '_' || IDENTRSAIDOP || CDTIPOOPER || '_') > 0) OR (:CDTIPOOPER = 'T'))) T

    WHERE NF.CDEMPRESA = :CDEMPRESA                                                 AND
          ((NF.CDINSCESTA = :INSCESTA) OR (:INSCESTA = 'T'))                    AND
          ((NF.CDINSCMUNI = :INSCMUNI) OR (:INSCMUNI = 'T'))                    AND
          ((NF.CDSERIE = :CDSERIE) OR (:CDSERIE = 'T'))                             AND
          NF.IDENTRSAIDOP = T.IDENTRSAIDOP                                          AND
          NF.CDTIPOOPER = T.CDTIPOOPER                                              AND
          ((INSTR(:IDSITUACAONF, NF.IDSTATUSNFE)<>0) OR (:IDSITUACAONF = 'T'))    AND
          ((INSTR(:TIPOEMISSAO, NF.IDTIPOEMISNFE) > 0) OR (:TIPOEMISSAO = 'T')) AND
          (NF.NRINSJURNF = :CLIENTE OR :CLIENTE = 'T')                          AND
          (NF.CDFILIRECE = :CDFILIRECE  OR :CDFILIRECE = 'T')                   AND
          T.CDTPCTRECEB = TR.CDTPCTRECEB(+)                                         AND
          NF.CDCLIENTE = C.CDCLIENTE(+)                                             AND
          NF.CDFORNECED = FO.CDFORNECED(+)                                          AND
          NF.CDFILIRECE = FI.CDFILIAL(+)                                            AND
          NF.CDCLIENTE = L.CDCLIENTE(+)                                             AND
          NF.NRLICENCAUSO = L.NRLICENCAUSO(+)                                       AND
          NF.CDFILIAL = CT.CDFILIAL(+)                                              AND
          NF.NRAPURACFAT = CT.NRAPURACFAT(+)                                        AND
          ((:CDROTATRANS = 'T') OR (EXISTS(SELECT 1
                                                FROM FILIALROTA
                                               WHERE FILIALROTA.CDFILIROTA = NF.CDFILIRECE
                                                 AND INSTR(:CDROTATRANS, '_' || CDROTATRANS || '_') > 0)))
    ORDER BY 1, 2, 3, 4, 5, 6

SQL;



        $params = array(
            "CDFILIAL"   => $args["cdfilial"],
            "CDFILIRECE"   => $args["cdfilirece"],
            "IDMODO"     => $args["idmodo"],
            "DATAINICIO" => $args["datainicio"],
            "DATAFINAL"  => $args["datafinal"],
            "CDTIPOOPER"  => $args["cdtipooper"],
            "CDEMPRESA"  => $args["cdempresa"],
            "INSCMUNI"  => $args["inscmuni"],
            "INSCESTA"  => $args["inscesta"],
            "CDSERIE"  => $args["cdserie"],
            "IDSITUACAONF"  => $args["idsituacaonf"],
            "TIPOEMISSAO"  => $args["tipoemissao"],
            "CLIENTE"  => $args["cliente"],
            "CDROTATRANS"  => $args["cdrotatrans"]
        );

        return \Setforms2\Shared\Connection::getInstance()->fetchAll($sql, $params);
    }


    public static function consultaNotaFiscalEntradaNFE($args)
    {
        $sql = <<<SQL
    SELECT NF.NRORG, NF.CDEMPRESA,           NF.CDINSCESTA,        NF.CDINSCMUNI,
           NF.CDSERIEENTR CDSERIE, NF.NRNOTAFISCALELE,   NF.NRLANCTONF,
           NF.CDFILIAL,            NF.IDBLOQUEADO,       NF.CDOPERAPRO,
           NF.IDDOCFISCAL,         NF.IDENTRSAIDOP,      NF.IDDOCFINANC,
           NF.CDTIPOOPER,          NF.IDTPIJURNF,        NF.NRINSJURNF,
           NF.IDSTATUS,            NF.CDFORNECED,        NF.NRLANCTBDOC,
           NF.VRNOTAFISC,          NF.IDERROS,           NF.IDAVISOS,
           NF.CDCLIENTE,           NF.DTEMISSAO,         NF.CDFILIRECE,
           NF.IDORIGDESTNF,        NF.IDSISTEMA,         NF.NRLICENCAUSO,
           NF.NRAPURACFAT,         T.NMTIPOOPER,         T.CDTPCTPAGAR AS CDTPCTRECOP,
           T.IDCONTABOPER,         (' ') AS IDERROAVISO, NF.CDFILIEMIT,
           ('U') AS IDCHECK,       NF.DTENTRSAID,        0.0 AS VRPEMORBCLI,
           0.0 AS VRPEMULBCLI,     NF.IDUTLIBERANF,      NF.CDINTEGRACAO,
           NF.IDSTATUSNFE,         NF.CDMODDOCFISC,      NF.DSOBSSTATUSNFE,
           NF.NRACESSONFE,         NF.NRPROTOCOLONFE,    NF.NRNOTAFISC,
           NF.IDEMAILNFE,          NF.IDTIPOEMISNFE,     NF.IDTPAMBNFE,
           NF.IDEMAILNFETRANSP,    NF.NRINSJURTRAN,
           C.NMRAZSOCCLIE AS NMRAZSOCCLIE,
           TR.CDCLASSFINA AS CDCLAFINOP,
           NF.CDSERIEENTR AS CDSERIENUMNF,
           TO_CHAR(NF.DTENTRSAID, 'DD/MM/YYYY') AS DATASAIDA,
           TO_CHAR(NF.DTEMISSAO, 'DD/MM/YYYY')  AS DATAEMISSAO,
           CAST('' AS VARCHAR2(01)) AS IDAPURACOK,
           CAST('' AS VARCHAR2(10)) AS NRAPURACFAT,
           SUBSTR('Data Saída: '||TO_CHAR(NF.DTENTRSAID)||' Data Emissão: '||TO_CHAR(NF.DTEMISSAO)||' Seq.: '||NF.NRLANCTONF||' ('||T.NMTIPOOPER||')',1,120) AS DTNOTAFISC
    FROM TIPOCTPAGAR TR, CLIENTE C,
         (SELECT /*+ INDEX(N NOTAFISCAL_09) */
                 N.NRORG, N.CDEMPRESA,                 N.CDINSCESTA,      N.CDINSCMUNI,
                 S.CDSERIEENTRNFE AS CDSERIE, N.NRNOTAFISCALELE, N.NRLANCTONF,
                 N.CDFILIAL,                  N.IDBLOQUEADO,     N.CDOPERAPRO,
                 N.IDDOCFISCAL,               N.IDENTRSAIDOP,    N.NRNOTAFISC,
                 N.IDDOCFINANC,               N.CDTIPOOPER,      N.IDTPIJURNF,
                 N.NRINSJURNF,                N.IDSTATUS,        N.CDFORNECED,
                 N.NRLANCTBDOC,               N.VRNOTAFISC,      N.IDERROS,
                 N.IDAVISOS,                  N.CDCLIENTE,       N.CDFILIRECE,
                 N.IDORIGDESTNF,              N.IDSISTEMA,       N.NRLICENCAUSO,
                 N.NRAPURACFAT,               N.DTENTRSAID,      N.CDFILIEMIT,
                 N.CDINTEGRACAO,              N.NREXPEDICAO,     FF.IDUTLIBERANF,
                 N.CDSERIEENTR,               N.IDSTATUSNFE,     N.DSOBSSTATUSNFE,
                 N.CDMODDOCFISC,              N.NRACESSONFE,     N.NRPROTOCOLONFE,
                 N.IDEMAILNFE,                N.IDTIPOEMISNFE,   N.IDTPAMBNFE,
                 NVL(N.IDEMAILNFETRANSP, 'N') IDEMAILNFETRANSP,  N.NRINSJURTRAN,
                 DECODE(NVL(P.IDUTDTPROCTNFE,'N'), 'S', DECODE(TP.IDTPTRANSNFE,'F', N.DTEMISSAO, NVL(N.DTEMISSAO, N.DTENTRSAID)), NVL(N.DTEMISSAO, N.DTENTRSAID)) DTEMISSAO
            FROM NOTAFISCAL N, SERIEENTR S, PARAMGERAL P, TIPOOPERAC TP,
                 (SELECT F.CDFILIAL, P.IDUTLIBERANF
                    FROM FILIAL F, PARAMFILIAL P
                   WHERE NVL(F.CDFILIFISC, F.CDFILIAL) = NVL(:CDFILIAL, NVL(F.CDFILIFISC, F.CDFILIAL))
                     AND NVL(F.CDFILIFISC, F.CDFILIAL) = P.CDFILIAL
                     AND :IDMODO = 'N'
                 UNION ALL
                  SELECT F.CDFILIAL, P.IDUTLIBERANF
                    FROM FILIAL F, PARAMFILIAL P
                   WHERE F.CDFILIAL = :CDFILIAL
                     AND F.CDFILIAL = P.CDFILIAL
                    AND :IDMODO = 'F') FF
           WHERE N.CDTIPOOPER   = TP.CDTIPOOPER
             AND N.IDENTRSAIDOP = TP.IDENTRSAIDOP
             AND N.CDFILIRECE   = FF.CDFILIAL
             AND N.IDENTRSAIDOP = 'E'
             AND N.DTENTRSAID BETWEEN :DATAINICIO AND :DATAFINAL
             AND N.CDSERIEENTR  = S.CDSERIEENTR) NF,

         (SELECT IDENTRSAIDOP, CDTIPOOPER, NMTIPOOPER,
                 CDTPCTPAGAR, IDCONTABOPER, IDUTILEMISNF
            FROM TIPOOPERAC
           WHERE IDENTRSAIDOP = 'E'
             AND DECODE(IDTPTRANSNFE, 'C', 'N', IDTPTRANSNFE) = :IDMODO
             AND ((INSTR(:CDTIPOOPER, '_' || IDENTRSAIDOP || CDTIPOOPER || '_') > 0) OR (:CDTIPOOPER = 'T'))) T
    WHERE NF.CDEMPRESA                = :CDEMPRESA
      AND ((NF.CDINSCESTA             = :INSCESTA) OR (:INSCESTA = 'T'))
      AND ((NF.CDINSCMUNI             = :INSCMUNI) OR (:INSCMUNI = 'T'))
      AND ((NF.CDSERIEENTR            = :CDSERIE)    OR (:CDSERIE = 'T'))
      AND NF.IDENTRSAIDOP             = T.IDENTRSAIDOP
      AND NF.CDTIPOOPER               = T.CDTIPOOPER
      AND T.IDUTILEMISNF              = 'S'
      AND ((NVL(NF.IDORIGDESTNF, 'F') = :IDORIGDESTNF) OR (:IDORIGDESTNF = 'T'))
      AND (NVL(NF.IDORIGDESTNF, 'C')  = 'C')
      AND (NF.NRINSJURNF              = :CLIENTE       OR :CLIENTE = 'T')
      AND ((INSTR(:IDSITUACAONF, NF.IDSTATUSNFE) <> 0)  OR (:IDSITUACAONF = 'T'))
      AND ((INSTR(:TIPOEMISSAO, NF.IDTIPOEMISNFE) > 0) OR (:TIPOEMISSAO = 'T'))
      AND T.CDTPCTPAGAR               = TR.CDTPCTPAGAR(+)
      AND NF.CDCLIENTE                = C.CDCLIENTE
      AND ((:CDROTATRANS = 'T') OR (EXISTS(SELECT 1
                                                FROM FILIALROTA
                                               WHERE FILIALROTA.CDFILIROTA = NF.CDFILIRECE
                                                 AND INSTR(:CDROTATRANS, '_' || CDROTATRANS || '_') > 0)))
    UNION ALL
    SELECT NF.NRORG, NF.CDEMPRESA,           NF.CDINSCESTA,        NF.CDINSCMUNI,
           NF.CDSERIEENTR CDSERIE, NF.NRNOTAFISCALELE,   NF.NRLANCTONF,
           NF.CDFILIAL,            NF.IDBLOQUEADO,       NF.CDOPERAPRO,
           NF.IDDOCFISCAL,         NF.IDENTRSAIDOP,      NF.IDDOCFINANC,
           NF.CDTIPOOPER,          NF.IDTPIJURNF,        NF.NRINSJURNF,
           NF.IDSTATUS,            NF.CDFORNECED,        NF.NRLANCTBDOC,
           NF.VRNOTAFISC,          NF.IDERROS,           NF.IDAVISOS,
           NF.CDCLIENTE,           NF.DTEMISSAO,         NF.CDFILIRECE,
           NF.IDORIGDESTNF,        NF.IDSISTEMA,         NF.NRLICENCAUSO,
           NF.NRAPURACFAT,         T.NMTIPOOPER,         T.CDTPCTPAGAR AS CDTPCTRECOP,
           T.IDCONTABOPER,         (' ') AS IDERROAVISO, NF.CDFILIEMIT,
           ('U') AS IDCHECK,       NF.DTENTRSAID,        0.0 AS VRPEMORBCLI,
           0.0 AS VRPEMULBCLI,     NF.IDUTLIBERANF,      NF.CDINTEGRACAO,
           NF.IDSTATUSNFE,         NF.CDMODDOCFISC,      NF.DSOBSSTATUSNFE,
           NF.NRACESSONFE,         NF.NRPROTOCOLONFE,    NF.NRNOTAFISC,
           NF.IDEMAILNFE,          NF.IDTIPOEMISNFE,     NF.IDTPAMBNFE,
           NF.IDEMAILNFETRANSP,    NF.NRINSJURTRAN,
           F.NMRAZSOCFORN AS NMRAZSOCCLIE,
           TR.CDCLASSFINA AS CDCLAFINOP,
           NF.CDSERIEENTR AS CDSERIENUMNF,
           TO_CHAR(NF.DTENTRSAID, 'DD/MM/YYYY') DATASAIDA,
           TO_CHAR(NF.DTEMISSAO, 'DD/MM/YYYY') DATAEMISSAO,
           CAST('' AS VARCHAR2(01)) AS IDAPURACOK,
           CAST('' AS VARCHAR2(10)) AS NRAPURACFAT,
           SUBSTR('Data Saída: '||TO_CHAR(NF.DTENTRSAID)||' Data Emissão: '||TO_CHAR(NF.DTEMISSAO)||' Seq.: '||NF.NRLANCTONF||' ('||T.NMTIPOOPER||')',1,120) AS DTNOTAFISC
    FROM TIPOCTPAGAR TR, FORNECEDOR F,
         (SELECT /*+ INDEX(N NOTAFISCAL_09) */
                 N.NRORG, N.CDEMPRESA,                 N.CDINSCESTA,        N.CDINSCMUNI,
                 S.CDSERIEENTRNFE AS CDSERIE, N.NRNOTAFISCALELE,   N.NRLANCTONF,
                 N.CDFILIAL,                  N.IDBLOQUEADO,       N.CDOPERAPRO,
                 N.IDDOCFISCAL,               N.IDENTRSAIDOP,      N.IDDOCFINANC,
                 N.CDTIPOOPER,                N.IDTPIJURNF,        N.NRINSJURNF,
                 N.IDSTATUS,                  N.CDFORNECED,        N.NRLANCTBDOC,
                 N.VRNOTAFISC,                N.IDERROS,           N.IDAVISOS,
                 N.CDCLIENTE,                 N.CDFILIRECE,        N.IDORIGDESTNF,
                 N.IDSISTEMA,                 N.NRLICENCAUSO,      N.NRAPURACFAT,
                 N.DTENTRSAID,                N.CDFILIEMIT,        N.CDINTEGRACAO,
                 N.NREXPEDICAO,               FF.IDUTLIBERANF,     N.CDSERIEENTR,
                 N.IDSTATUSNFE,               N.DSOBSSTATUSNFE,    N.CDMODDOCFISC,
                 N.NRNOTAFISC,                N.NRACESSONFE,       N.NRPROTOCOLONFE,
                 N.IDEMAILNFE,                N.IDTIPOEMISNFE,     N.IDTPAMBNFE,
                 NVL(N.IDEMAILNFETRANSP, 'N') IDEMAILNFETRANSP,    N.NRINSJURTRAN,
                 DECODE(NVL(P.IDUTDTPROCTNFE,'N'), 'S', DECODE(TP.IDTPTRANSNFE,'F', N.DTEMISSAO, NVL(N.DTEMISSAO, N.DTENTRSAID)), NVL(N.DTEMISSAO, N.DTENTRSAID)) DTEMISSAO
            FROM NOTAFISCAL N, SERIEENTR S,  PARAMGERAL P, TIPOOPERAC TP,
                 (SELECT F.CDFILIAL, P.IDUTLIBERANF
                    FROM FILIAL F, PARAMFILIAL P
                   WHERE NVL(F.CDFILIFISC, F.CDFILIAL) = NVL(:CDFILIAL, NVL(F.CDFILIFISC, F.CDFILIAL))
                     AND NVL(F.CDFILIFISC, F.CDFILIAL) = P.CDFILIAL
                     AND :IDMODO = 'N'
                 UNION ALL
                  SELECT F.CDFILIAL, P.IDUTLIBERANF
                    FROM FILIAL F, PARAMFILIAL P
                   WHERE F.CDFILIAL = :CDFILIAL
                     AND F.CDFILIAL = P.CDFILIAL
                     AND :IDMODO = 'F') FF
           WHERE N.CDTIPOOPER   = TP.CDTIPOOPER
             AND N.IDENTRSAIDOP = TP.IDENTRSAIDOP
             AND N.CDFILIRECE   = FF.CDFILIAL
             AND N.IDENTRSAIDOP = 'E'
             AND N.DTENTRSAID BETWEEN :DATAINICIO AND :DATAFINAL
             AND N.CDSERIEENTR  = S.CDSERIEENTR
                      AND NVL(N.IDSISTEMA, 'DFS') <> 'CMP'
             AND NVL(N.IDSISTEMA, 'DFS') <> 'PAG') NF,

         (SELECT IDENTRSAIDOP, CDTIPOOPER, NMTIPOOPER,
                 CDTPCTPAGAR, IDCONTABOPER, IDUTILEMISNF
            FROM TIPOOPERAC
           WHERE IDENTRSAIDOP = 'E'
             AND DECODE(IDTPTRANSNFE, 'C', 'N', IDTPTRANSNFE) = :IDMODO
             AND ((INSTR(:CDTIPOOPER, '_' || IDENTRSAIDOP || CDTIPOOPER || '_') > 0) OR (:CDTIPOOPER = 'T'))) T
    WHERE NF.CDEMPRESA                = :CDEMPRESA
      AND ((NF.CDINSCESTA             = :INSCESTA) OR (:INSCESTA = 'T'))
      AND ((NF.CDINSCMUNI             = :INSCMUNI) OR (:INSCMUNI = 'T'))
      AND ((NF.CDSERIEENTR            = :CDSERIE)    OR (:CDSERIE = 'T'))
      AND NF.IDENTRSAIDOP             = T.IDENTRSAIDOP
      AND NF.CDTIPOOPER               = T.CDTIPOOPER
      AND T.IDUTILEMISNF              = 'S'
      AND ((NVL(NF.IDORIGDESTNF, 'F') = :IDORIGDESTNF) OR (:IDORIGDESTNF = 'T'))
      AND (NVL(NF.IDORIGDESTNF, 'F')  = 'F')
      AND (NF.NRINSJURNF              = :CLIENTE       OR :CLIENTE = 'T')
      AND ((INSTR(:IDSITUACAONF, NF.IDSTATUSNFE) <> 0)  OR (:IDSITUACAONF = 'T'))
      AND ((INSTR(:TIPOEMISSAO, NF.IDTIPOEMISNFE) > 0) OR (:TIPOEMISSAO = 'T'))
      AND T.CDTPCTPAGAR               = TR.CDTPCTPAGAR(+)
      AND NF.CDFORNECED               = F.CDFORNECED
      AND((:CDROTATRANS = 'T') OR (EXISTS(SELECT 1
                                               FROM FILIALROTA
                                         WHERE FILIALROTA.CDFILIROTA = NF.CDFILIRECE
                                           AND INSTR(:CDROTATRANS, '_' || CDROTATRANS || '_') > 0)))
    UNION ALL
    SELECT NF.NRORG, NF.CDEMPRESA,           NF.CDINSCESTA,        NF.CDINSCMUNI,
           NF.CDSERIEENTR CDSERIE, NF.NRNOTAFISCALELE,   NF.NRLANCTONF,
           NF.CDFILIAL,            NF.IDBLOQUEADO,       NF.CDOPERAPRO,
           NF.IDDOCFISCAL,         NF.IDENTRSAIDOP,      NF.IDDOCFINANC,
           NF.CDTIPOOPER,          NF.IDTPIJURNF,        NF.NRINSJURNF,
           NF.IDSTATUS,            NF.CDFORNECED,        NF.NRLANCTBDOC,
           NF.VRNOTAFISC,          NF.IDERROS,           NF.IDAVISOS,
           NF.CDCLIENTE,           NF.DTEMISSAO,         NF.CDFILIRECE,
           NF.IDORIGDESTNF,        NF.IDSISTEMA,         NF.NRLICENCAUSO,
           NF.NRAPURACFAT,         T.NMTIPOOPER,         T.CDTPCTPAGAR AS CDTPCTRECOP,
           T.IDCONTABOPER,         (' ') AS IDERROAVISO, NF.CDFILIEMIT,
           ('U') AS IDCHECK,       NF.DTENTRSAID,        0.0 AS VRPEMORBCLI,
           0.0 AS VRPEMULBCLI,     NF.IDUTLIBERANF,      NF.CDINTEGRACAO,
           NF.IDSTATUSNFE,         NF.CDMODDOCFISC,      NF.DSOBSSTATUSNFE,
           NF.NRACESSONFE,         NF.NRPROTOCOLONFE,    NF.NRNOTAFISC,
           NF.IDEMAILNFE,          NF.IDTIPOEMISNFE,     NF.IDTPAMBNFE,
           NF.IDEMAILNFETRANSP,    NF.NRINSJURTRAN,
           FI.NMFILIAL AS NMRAZSOCCLIE,
           TR.CDCLASSFINA AS CDCLAFINOP,
           NF.CDSERIEENTR AS CDSERIENUMNF,
           TO_CHAR(NF.DTENTRSAID, 'DD/MM/YYYY') DATASAIDA,
           TO_CHAR(NF.DTEMISSAO, 'DD/MM/YYYY') DATAEMISSAO,
           CAST('' AS VARCHAR2(01)) AS IDAPURACOK,
           CAST('' AS VARCHAR2(10)) AS NRAPURACFAT,
           SUBSTR('Data Saída: '||TO_CHAR(NF.DTENTRSAID)||' Data Emissão: '||TO_CHAR(NF.DTEMISSAO)||' Seq.: '||NF.NRLANCTONF||' ('||T.NMTIPOOPER||')',1,120) AS DTNOTAFISC
    FROM TIPOCTPAGAR TR, FILIAL FI,
         (SELECT /*+ INDEX(N NOTAFISCAL_09) */
                 N.NRORG, N.CDEMPRESA,                 N.CDINSCESTA,      N.CDINSCMUNI,
                 S.CDSERIEENTRNFE AS CDSERIE, N.NRNOTAFISCALELE, N.NRLANCTONF,
                 N.CDFILIAL,                  N.IDBLOQUEADO,     N.CDOPERAPRO,
                 N.IDDOCFISCAL,               N.IDENTRSAIDOP,    N.IDDOCFINANC,
                 N.CDTIPOOPER,                N.IDTPIJURNF,      N.NRINSJURNF,
                 N.IDSTATUS,                  N.CDFORNECED,      N.NRLANCTBDOC,
                 N.VRNOTAFISC,                N.IDERROS,         N.IDAVISOS,
                 N.CDCLIENTE,                 N.CDFILIRECE,      N.IDORIGDESTNF,
                 N.IDSISTEMA,                 N.NRLICENCAUSO,    N.NRAPURACFAT,
                 N.DTENTRSAID,                N.CDFILIEMIT,      N.CDINTEGRACAO,
                 N.NREXPEDICAO,               FF.IDUTLIBERANF,   N.CDSERIEENTR,
                 N.IDSTATUSNFE,               N.DSOBSSTATUSNFE,  N.CDMODDOCFISC,
                 N.NRACESSONFE,               N.NRPROTOCOLONFE,  N.NRNOTAFISC,
                 N.IDEMAILNFE,                N.IDTIPOEMISNFE,   N.IDTPAMBNFE ,
                 NVL(N.IDEMAILNFETRANSP, 'N') IDEMAILNFETRANSP,  N.NRINSJURTRAN,
                 DECODE(NVL(P.IDUTDTPROCTNFE,'N'), 'S', DECODE(TP.IDTPTRANSNFE,'F', N.DTEMISSAO, NVL(N.DTEMISSAO, N.DTENTRSAID)), NVL(N.DTEMISSAO, N.DTENTRSAID)) DTEMISSAO
            FROM NOTAFISCAL N, SERIEENTR S,  PARAMGERAL P, TIPOOPERAC TP,
                 (SELECT F.CDFILIAL, P.IDUTLIBERANF
                    FROM FILIAL F, PARAMFILIAL P
                   WHERE NVL(F.CDFILIFISC, F.CDFILIAL) = NVL(:CDFILIAL, NVL(F.CDFILIFISC, F.CDFILIAL))
                     AND NVL(F.CDFILIFISC, F.CDFILIAL) = P.CDFILIAL
                     AND :IDMODO = 'N'
                 UNION ALL
                  SELECT F.CDFILIAL, P.IDUTLIBERANF
                    FROM FILIAL F, PARAMFILIAL P
                   WHERE F.CDFILIAL = :CDFILIAL
                     AND F.CDFILIAL = P.CDFILIAL
                     AND :IDMODO = 'F') FF
           WHERE N.CDTIPOOPER = TP.CDTIPOOPER
             AND N.IDENTRSAIDOP = TP.IDENTRSAIDOP
             AND N.CDFILIRECE   = FF.CDFILIAL
             AND N.IDENTRSAIDOP = 'E'
             AND N.DTENTRSAID BETWEEN :DATAINICIO AND :DATAFINAL
             AND N.CDSERIEENTR = S.CDSERIEENTR
             AND NVL(N.IDSISTEMA, 'DFS') <> 'CMP'
             AND NVL(N.IDSISTEMA, 'DFS') <> 'PAG') NF,

         (SELECT IDENTRSAIDOP, CDTIPOOPER, NMTIPOOPER,
                 CDTPCTPAGAR, IDCONTABOPER, IDUTILEMISNF
            FROM TIPOOPERAC
           WHERE IDENTRSAIDOP = 'E'
             AND DECODE(IDTPTRANSNFE, 'C', 'N', IDTPTRANSNFE) = :IDMODO
             AND ((INSTR(:CDTIPOOPER, '_' || IDENTRSAIDOP || CDTIPOOPER || '_') > 0) OR (:CDTIPOOPER = 'T'))) T
    WHERE NF.CDEMPRESA                = :CDEMPRESA
      AND ((NF.CDINSCESTA             = :INSCESTA) OR (:INSCESTA = 'T'))
      AND ((NF.CDINSCMUNI             = :INSCMUNI) OR (:INSCMUNI = 'T'))
      AND ((NF.CDSERIEENTR            = :CDSERIE)    OR (:CDSERIE = 'T'))
      AND NF.IDENTRSAIDOP             = T.IDENTRSAIDOP
      AND NF.CDTIPOOPER               = T.CDTIPOOPER
      AND T.IDUTILEMISNF              = 'S'
      AND ((NVL(NF.IDORIGDESTNF, 'F') = :IDORIGDESTNF) OR (:IDORIGDESTNF = 'T'))
      AND (NVL(NF.IDORIGDESTNF, 'L')  = 'L')
      AND (NF.NRINSJURNF              = :CLIENTE       OR :CLIENTE = 'T')
      AND ((INSTR(:IDSITUACAONF, NF.IDSTATUSNFE) <> 0)  OR (:IDSITUACAONF = 'T'))
      AND ((INSTR(:TIPOEMISSAO, NF.IDTIPOEMISNFE) > 0) OR (:TIPOEMISSAO = 'T'))
      AND T.CDTPCTPAGAR               = TR.CDTPCTPAGAR(+)
      AND NF.CDFILIEMIT               = FI.CDFILIAL
      AND ((:CDROTATRANS = 'T') OR (EXISTS(SELECT 1
                                                FROM FILIALROTA
                                               WHERE FILIALROTA.CDFILIROTA = NF.CDFILIRECE
                                                 AND INSTR(:CDROTATRANS, '_' || CDROTATRANS || '_') > 0)))

    ORDER BY 1, 2, 3, 4, 5, 6

SQL;

        $params = array(
            "CDFILIAL"   => $args["cdfilial"],
            "IDMODO"     => $args["idmodo"],
            "DATAINICIO" => $args["datainicio"],
            "DATAFINAL"  => $args["datafinal"],
            "CDTIPOOPER"  => $args["cdtipooper"],
            "CDEMPRESA"  => $args["cdempresa"],
            "INSCMUNI"  => $args["inscmuni"],
            "INSCESTA"  => $args["inscesta"],
            "CDSERIE"  => $args["cdserie"],
            "IDSITUACAONF"  => $args["idsituacaonf"],
            "TIPOEMISSAO"  => $args["tipoemissao"],
            "CLIENTE"  => $args["cliente"],
            "CDROTATRANS"  => $args["cdrotatrans"],
            "IDORIGDESTNF" => $args["idorigdestnf"],
        );

        return \Setforms2\Shared\Connection::getInstance()->fetchAll($sql, $params);
    }


    public function getCorpoNotaFiscal($cdfilial, $nrlanctonf, $idorigdestnf, $identrsaid, $nrorg)
    {
        try{
            switch($idorigdestnf) {
            case "F": {
                if($identrsaid === "S") {
                    $resultSet = $this->consultaCorpoNFFornecedor($cdfilial, $nrlanctonf, $nrorg);
                }else{
                    $resultSet = $this->consultaCorpoNFFornecedorEntrada($cdfilial, $nrlanctonf, $nrorg);
                }
                break;
            }
            case "L": {
                if($identrsaid === "S") {
                    $resultSet = $this->consultaCorpoNFFilial($cdfilial ,$nrlanctonf, $nrorg);
                } else {
                    $resultSet = $this->consultaCorpoNFFilialEntrada($cdfilial ,$nrlanctonf, $nrorg);
                }
                break;
            }
            default: {
            if($identrsaid === "S") {
                $resultSet = $this->consultaCorpoNFCliente($cdfilial, $nrlanctonf, $nrorg);
            }else{
                $resultSet = $this->consultaCorpoNFClienteEntrada($cdfilial, $nrlanctonf, $nrorg);
            }
            break;
            }
            }

            // Return current resultSet to get first line from array since array should return 1 row always
            return empty($resultSet) ? $resultSet : current($resultSet);
        } catch(\Exception $e) {
            throw $e;
        }
    }

    public function consultaInscricaoSuframaNFE($cliente)
    {
        $sql = <<<SQL
        SELECT NRINSCSUFRAMAFI AS NRSUFRAMA
          FROM FILIAL
         WHERE CDFILIAL     = :P_CLIENTE
        UNION ALL
        SELECT NRINSCSUFRAMAFO AS NRSUFRAMA
          FROM FORNECEDOR
         WHERE CDFORNECED   = :P_CLIENTE
        UNION ALL
        SELECT NRINSCSUFRAMACL AS NRSUFRAMA
          FROM CLIENTE
         WHERE CDCLIENTE    = :P_CLIENTE
SQL;

        return self::getEntityManager()->getConnection()->fetchAll($sql, array("P_CLIENTE" => $cliente));
    }

    public function consultaNotaFiscalJaExiste($cdforneced, $cdserie, $nrnotafisc, $cdtipooper, $nrorg){

        $sql = "
            SELECT DTENTRSAID, CDFILIAL
            FROM NOTAFISCAL
            WHERE (CDFORNECED            = :P_FORNECED)
            AND (CDSERIEENTR             = :P_SERIE)
            AND (LPAD(NRNOTAFISC,20,'0') = LPAD(:P_NOTAFISC,20,'0'))
            AND NRORG          = :P_NRORG
            AND NOT EXISTS
              (SELECT 1
              FROM TIPOOPERAC
              WHERE CDTIPOOPER   = :P_CDTIPOOPER
              AND IDENTRSAIDOP   = NOTAFISCAL.IDENTRSAIDOP
              AND IDINFCPFCNPJNF = 'S'
              AND CDFORNECEDPADR = NOTAFISCAL.CDFORNECED
              AND NRORG          = :P_NRORG
              )
            ORDER BY DTENTRSAID DESC
        ";

        $params = array(
            'P_FORNECED'   => $cdforneced,
            'P_SERIE'      => $cdserie,
            'P_NOTAFISC'   => $nrnotafisc,
            'P_NRORG'      => $nrorg,
            'P_CDTIPOOPER' => $cdtipooper
        );

        return self::getEntityManager()->getConnection()->fetchColumn($sql, $params, 1);

    }

    public static function deleteNotaFiscal($nrorg, $nrlanctonf)
    {
        $sql = <<<SQL
               		DELETE FROM NOTAFISCAL WHERE NRLANCTONF = '$nrlanctonf' AND NRORG = '$nrorg'
SQL;
        return \Setforms2\Shared\Registry::getEntityManager()->getConnection()->exec($sql);
    }

    public static function consultaNotaDevolucao($cdfilial, $nrlanctonf, $nrorg){
        $sql = <<<SQL
        SELECT NF.NRACESSONFE, IDTIPOEMISNFE,
               DECODE(IDTIPOEMISNFE, '3', NVL(S.CDSERIENFESCAN, SE.CDSERIEENTSCAN), NVL(S.CDSERIENFE, SE.CDSERIEENTRNFE)) AS CDSERIE
          FROM ITEMNOTAFISC IT, NOTAFISCAL NF, SERIENF S, SERIEENTR SE
         WHERE IT.CDFILIAL = :P_CDFILIAL
           AND IT.NRLANCTONF = :P_NRLANCTONF
           AND IT.NRORG     = :P_NRORG
           AND IT.CDFILIALIT = NF.CDFILIAL
           AND IT.NRLANCTONFIT = NF.NRLANCTONF
           AND IT.NRORG       = NF.NRORG
           AND NF.CDEMPRESA = S.CDEMPRESA(+)
           AND NF.CDINSCESTA = S.CDINSCESTA(+)
           AND NF.CDINSCMUNI = S.CDINSCMUNI(+)
           AND NF.CDSERIE = S.CDSERIE(+)
           AND NF.CDSERIEENTR = SE.CDSERIEENTR(+)
SQL;

        $params = array(
            'P_CDFILIAL'      => $cdfilial,
            'P_NRLANCTONF'   => $nrlanctonf,
            'P_NRORG'      => $nrorg
        );

        return self::getEntityManager()->getConnection()->fetchAll($sql, $params);
    }

    public function buscaNotaOrigem($idtpijurnf, $nrinsjurnf, $nrnotafisc, $cdserie, $cdfilial, $nrorg){
      $sql = <<<SQL
        SELECT A.CDFILIAL, A.NRLANCTONF, A.CDFORNECED,
                 A.NRINSJURNF, A.IDTPIJURNF, A.CDSERIEENTR, A.NRNOTAFISC, A.DTENTRSAID,
                 A.VRNOTAFISC, DECODE(A.IDORIGDESTNF, 'C', C.NMRAZSOCCLIE, 'F', B.NMRAZSOCFORN, F.NMFILIAL) AS NMRAZSOCFORN,
                 TO_CHAR(A.DTENTRSAID, 'DD/MM/YYYY') AS ENTRADA
          FROM NOTAFISCAL A, FORNECEDOR B, CLIENTE C, FILIAL F
          WHERE (A.IDTPIJURNF = NVL(:P_IDTPIJURNF,A.IDTPIJURNF)) AND
                (A.NRINSJURNF = NVL(:P_NRINSJURNF,A.NRINSJURNF)) AND
                (A.NRNOTAFISC   = :P_NOTAFISC   ) AND
                (A.CDSERIEENTR  = :P_SERIE      ) AND
                (A.CDFILIRECE   = :P_FILIAL)    AND
                (A.NRORG        = :P_NRORG)     AND    
                (A.CDFORNECED = B.CDFORNECED(+)) AND
                (A.CDCLIENTE = C.CDCLIENTE(+)) AND
                (A.CDFILIEMIT = F.CDFILIAL(+)) AND
                (A.IDENTRSAIDOP = 'E')
          ORDER BY A.CDFILIAL, A.NRLANCTONF
SQL;

        $params = array(
            'P_IDTPIJURNF'      => $idtpijurnf,
            'P_NRINSJURNF'      => $nrinsjurnf,
            'P_NOTAFISC'      => $nrnotafisc,
            'P_SERIE'   => $cdserie,
            'P_FILIAL'   => $cdfilial,
            'P_NRORG'      => $nrorg
        );

        return self::getEntityManager()->getConnection()->fetchAssoc($sql, $params);
    }

    public function dadosNF($cdfilial, $nrlanctonf, $nrorg){
        $sql = <<<SQL
        SELECT N.NRORG, N.IDSTATUS, N.DTEMISSAO, N.NRNOTAFISC, N.IDENTRSAIDOP, N.CDTIPOOPER,
               T.IDCONTABOPER, T.CDTPCTRECEB, T.CDTPCTPAGAR,
               TP.CDCLASSFINA AS CDCLAFINOP,
               TP.CDCLASSFINA CDCLASFINAPAG, TR.CDCLASSFINA CDCLASFINAREC,
               NVL(N.CDSERIEENTR, N.CDSERIE) AS CDSERIENUMNF,
               N.IDDOCFINANC, N.CDEMPRESA, N.CDINSCESTA, N.CDINSCMUNI, N.CDFILIRECE,
               N.CDFILIEMIT, N.IDORIGDESTNF, N.CDCLIENTE, N.VRNOTAFISC, N.DTENTRSAID,
               N.CDFILIAL, N.NRLANCTONF, N.NRLANCTBDOC, N.CDFORNECED, N.IDTPIJURNF,
               N.NRINSJURNF,T.CDTPCTRECEB AS CDTPCTRECOP, NVL(C.IDPRIPUBCLIE, '') AS IDPRIPUBCLIE,
               N.IDSISTEMA, T.IDOPERDEVONF, T.IDDTCONTAB, N.NRSEQUMAPAPUNF, N.VRPRODUTOS, N.IDSTATUSNFE,
               T.IDUTILVENC, N.IDBLOQNFFIN, N.IDERROS, N.IDAVISOS, T.IDGERAVENCNFAP
        FROM NOTAFISCAL N, TIPOOPERAC T, SERIENF S,
             TIPOCTPAGAR TP,CLIENTE C, TIPOCTRECEBER TR
        WHERE N.CDFILIAL     = :P_CDFILIAL       AND
              N.NRLANCTONF   = :P_NRLANCTONF     AND
              N.NRORG        = :P_NRORG          AND
              N.CDCLIENTE    = C.CDCLIENTE(+)       AND
              N.NRORG        = C.NRORG(+)        AND
              N.IDENTRSAIDOP = T.IDENTRSAIDOP    AND
              N.CDTIPOOPER   = T.CDTIPOOPER      AND
              N.NRORG        = T.NRORG           AND
              N.CDEMPRESA    = S.CDEMPRESA(+)    AND
              N.CDINSCESTA   = S.CDINSCESTA(+)   AND
              N.CDINSCMUNI   = S.CDINSCMUNI(+)   AND
              N.CDSERIE      = S.CDSERIE(+)      AND
              N.NRORG        = S.NRORG(+)        AND
              T.CDTPCTRECEB  = TR.CDTPCTRECEB(+) AND
              T.NRORG        = TR.NRORG(+)       AND
              T.CDTPCTPAGAR  = TP.CDTPCTPAGAR(+) AND
              T.NRORG        = TP.NRORG(+)
SQL;

        $params = array(
            'P_CDFILIAL'      => $cdfilial,
            'P_NRLANCTONF'   => $nrlanctonf,
            'P_NRORG'      => $nrorg
        );

        return $this->getEntityManager()->getConnection()->fetchAssoc($sql, $params);
    }

    public function getMaxNrnotafisc($cdfilial, $nrlanbolrec){
        $sql = <<<SQL
          SELECT MAX(NF.NRNOTAFISC) NRNOTAFISC
            FROM
               NOTAFISCAL   NF,
               CONTARECEBER CR
            WHERE
               NF.CDFILIAL     = CR.CDFILIAL   AND
               NF.NRLANCTONF   = CR.NRLANCTONF AND
               CR.CDFILIBOLREC = :P_CDFILIAL   AND
               CR.NRLANBOLREC  = :P_NRLANBOLREC

SQL;
        $params = array(
            "P_CDFILIAL" => $cdfilial,
            "P_NRLANBOLREC" => $nrlanbolrec
        );

        return $this->getEntityManager()->getConnection()->fetchAll($sql, $params);

    }


    public function getIntervaloInutilizacao($cdempresa, $cnpj, $serienfe, $ambiente){
        $sql = <<<SQL
        SELECT CDEMPRESA, NRCNPJINSESTNFE, CDSERNFE, IDTPAMBIENTENFE,
               INTERVALOINI, INTERVALOFIN, DTHRCONSINUTNFE
          FROM GRAVAINTINUTNFE
         WHERE CDEMPRESA = :P_CDEMPRESA
           AND NRCNPJINSESTNFE = :P_NRCNPJINSESTNFE
           AND CDSERNFE = :P_CDSERNFE
           AND IDTPAMBIENTENFE = :P_IDTPAMBIENTENFE
SQL;

        $params = array(
            'P_CDEMPRESA'      => $cdempresa,
            'P_NRCNPJINSESTNFE'   => $cnpj,
            'P_CDSERNFE'      => $serienfe,
            'P_IDTPAMBIENTENFE'      => $ambiente
        );

        return $this->getEntityManager()->getConnection()->fetchAssoc($sql, $params);
    }

    public function updGravaIntInutNFe($status, $observacao, $empresa, $serie, $intervaloIni, $intervaloFin, $cnpj, $ambiente){
        $sql = <<<SQL
        UPDATE GRAVAINTINUTNFE
           SET IDSTATUS = :P_IDSTATUS,
               DSOBSERVACAO = :P_DSOBSERVACAO
         WHERE CDEMPRESA = :P_CDEMPRESA
           AND CDSERNFE = :P_CDSERNFE
           AND INTERVALOINI = :P_INTERVALOINI
           AND INTERVALOFIN = :P_INTERVALOFIN
           AND NRCNPJINSESTNFE = :P_NRCNPJINSESTNFE
           AND IDTPAMBIENTENFE = :P_IDTPAMBIENTENFE
SQL;

        $params = array(
            'P_IDSTATUS'      => $status,
            'P_DSOBSERVACAO'   => $observacao,
            'P_CDEMPRESA'      => $empresa,
            'P_CDSERNFE'      => $serie,
            'P_INTERVALOINI'      => $intervaloIni,
            'P_INTERVALOFIN'      => $intervaloFin,
            'P_NRCNPJINSESTNFE'      => $cnpj,
            'P_IDTPAMBIENTENFE'      => $ambiente
        );

        return $this->getEntityManager()->getConnection()->executeUpdate($sql, $params);
    }

    public function getLastNextDateInutilizacao(){
        $sql = <<<SQL
        SELECT LAST_DATE AS DTHRULTIMACONSULTA, NEXT_DATE AS DTHRPROXIMACONSULTA
          FROM ALL_JOBS
         WHERE WHAT LIKE 'INUTILIZACAO_NFE%'
SQL;

        return $this->getEntityManager()->getConnection()->fetchAll($sql);
    }
    public function getIdErroAviso($cdfilial){
        $sql = <<<SQL
                  SELECT IDERROAVISOFIL
                    FROM ERROAVISONFFIL
                   WHERE CDERROAVISOFIL = 'ER03'
                     AND CDFILIAL = :P_CDFILIORIG
SQL;

        $params = array(
            "P_CDFILIORIG" => $cdfilial
        );

        return $this->getEntityManager()->getConnection()->fetchAll($sql, $params);
    }

    public function getValorTotalImposto($cdfilial, $nrlanctonf, $iderroaviso, $nrdectotanf){
        $sql = <<<SQL
                  SELECT ROUND(NVL(SUM(T.VRIMPOSTOT),0),:P_NRDECTOTANF) AS V_VRIMPOSTOT
                    FROM TRABIMPOSNFTOT T, IMPOSTO I
                   WHERE T.CDFILIMPTOT  = :P_CDFILIAL    AND
                         T.NRLANCIMPTOT = :P_NRLANCTONF  AND
                         :P_IDERROAVISO  <> 'N'          AND
                         T.CDIMPOSTOT   = I.CDIMPOSTO   AND
                         I.IDTRATIMPO   = 'R'           AND
                         I.IDDESCRFONTE = 'R'
SQL;

        $params = array(
            "P_CDFILIAL" => $cdfilial,
            "P_NRLANCTONF" => $nrlanctonf,
            "P_IDERROAVISO" => $iderroaviso,
            "P_NRDECTOTANF" => $nrdectotanf
        );

        return $this->getEntityManager()->getConnection()->fetchAll($sql, $params);
    }

    public function getValorSubtracaoVencimentos($cdfilial, $nrlanctonf, $identrsaid, $cdtipooper){
        $sql = <<<SQL
                  SELECT NVL(SUM(VRBRUTITEM),0) AS VRSUBTRAIVENC
                    FROM ITEMPRODUTO IT, TPOPERCFOP T
                   WHERE IT.CDFILIAL   = :P_CDFILIAL
                     AND IT.NRLANCTONF = :P_NRLANCTONF
                     AND T.IDENTRSAIDOP = :P_IDENTRSAID
                     AND T.CDTIPOOPER   = :P_CDTIPOOPER
                     AND T.IDCOMPOEVENC = 'N'
                     AND T.CDFISCOPER   = IT.CDFISOPEITEM
SQL;

        $params = array(
            "P_CDFILIAL"   => $cdfilial,
            "P_NRLANCTONF" => $nrlanctonf,
            "P_IDENTRSAID" => $identrsaid,
            "P_CDTIPOOPER" => $cdtipooper
        );

        return $this->getEntityManager()->getConnection()->fetchAll($sql, $params);
    }

    public function getValorTotalVencimentos($cdfilial, $nrlanctonf, $vrimpostot, $vrsubtraivenc){
        $sql = <<<SQL
                  SELECT ABS(NVL(SUM(VRORIGREC),(NF.VRNOTAFISC - :P_VRIMPOSTOT - :P_VRSUBTRAIVENC)) - (NF.VRNOTAFISC - :P_VRIMPOSTOT - :P_VRSUBTRAIVENC)) AS VRDIFERENCA
                    FROM CONTARECEBER CR, NOTAFISCAL NF
                   WHERE CR.CDFILIAL   =  :P_CDFILIAL
                     AND CR.NRLANCTONF =  :P_NRLANCTONF
                     AND NF.CDFILIAL = CR.CDFILIAL
                     AND NF.NRLANCTONF = CR.NRLANCTONF
                GROUP BY NF.VRNOTAFISC
SQL;

        $params = array(
            "P_CDFILIAL"   => $cdfilial,
            "P_NRLANCTONF" => $nrlanctonf,
            "P_VRIMPOSTOT" => $vrimpostot,
            "P_VRSUBTRAIVENC" => $vrsubtraivenc
        );

        return $this->getEntityManager()->getConnection()->fetchAll($sql, $params);
    }
    
    public function verificaNotaImportada($chaveAcesso){
      $sql = "SELECT n.NRLANCTONF
                FROM NOTAFISCAL N
               WHERE N.NRACESSONFE = :P_NRACESSONFE";
      $search = $this->getEntityManager()->getConnection()->prepare($sql);
      $search->bindValue("P_NRACESSONFE",$chaveAcesso);
      $search->execute();
      $result = $search->fetchAll();
      return $result;
    }

    public function saveNFE($params) {
                $sql = "INSERT INTO NOTAFISCAL
                    (DTCOMPFATUR   , CDFILIAL       , NRLANCTONF      , NRORG, CDEMPRESA       , CDINSCESTA     , CDINSCMUNI,
                    CDFILIEMIT     , CDFILIRECE     , IDTPIJURNF     , NRINSJURNF      , CDFORNECED      , CDCLIENTE ,
                    IDERROS        , IDAVISOS       , IDBLOQUEADO    , IDDOCFISCAL     , IDDOCFINANC     , NRNOTAFISC     , DTEMISSAO,
                    DTENTRSAID     , VRPRODUTOS     , VRNOTAFISC      , NRPLACAVEIC     , SGUFVEIC       , IDPGTOFRETE,
                    DSQTDEVOLU     , DSESPECVOLU    , DSMARCAVOLU     , DSNUMEVOLU      , VRPBRUTOVOLU   , VRPLIQUVOLU,
                    IDENTRSAIDOP   , CDTIPOOPER     , IDTPIJURTRAN    , NRINSJURTRAN    , CDFISOPENTF    , DSCDFISOPENF,
                    IDDOCCONTAB    , IDSTATUS       , IDSISTEMA       , CDMODDOCFISC    , CDSERIEENTR    , CDINTEGRACAO,
                    IDORIGDESTNF   , CDALMOXARIFE   , CDLOCALESTOQ    , DTLANCAMENNF    , CDOPERGERA     , NRCPFCNPJNF  ,
                    NRACESSONFE    , IDSTATUSNFE    , NRNOTAFISCALELE , DSOBSSTATUSNFE  , NRPROTOCOLONFE , IDTIPOEMISNFE,
                    IDTPAMBNFE     , DTHRPROTOCOLNFE, IDNFGERADAVIAXML, CDCHAVEACESNFPS , CDCFOPINFUSU   , DSCFOPINFUSU  ,
                    CDFORNECEDREME , IDTPIJURFORREME, NRINSJURFORREME , NRNFREMESSA)
                             VALUES (SYSDATE,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,LPAD(?,9,0),?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,
                                    ?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";
                $connection = $this->getEntityManager()->getConnection();
                      return  $connection->executeUpdate($sql,$params);
    }

    public function getCstDig1($numeroNota,$filial,$nrseqitprod){
        $sql = "SELECT NVL(NVL(P.CDCSTDIG1PROD ,F.CDCSTDIG1ENT), 0) AS CDCSTDIG1
                  FROM ITEMPRODUTO I, NOTAFISCAL N, FORNECEDOR F, PRODUTO P
                 WHERE I.CDFILIAL    = :P_CDFILIAL
                   AND I.NRLANCTONF  = :P_NRLANCTONF
                   AND I.NRSEQITPROD = LPAD(:P_NRSEQITPROD, 4, 0)
                   AND N.CDFILIAL    = I.CDFILIAL
                   AND N.NRLANCTONF  = I.NRLANCTONF
                   AND F.CDFORNECED  = N.CDFORNECED
                   AND P.CDPRODUTO   = I.CDPRODUTO";
        $search = $this->getEntityManager()->getConnection()->prepare($sql);
        $search->bindValue("P_CDFILIAL",$filial);
        $search->bindValue("P_NRLANCTONF",$numeroNota);
        $search->bindValue("P_NRSEQITPROD",$nrseqitprod);
        $search->execute();
        $result = $search->fetchAll();
        return $result;
    }

     public function saveContaPagar($params,$dtEmissao){
        $sql = "INSERT INTO CONTAPAGAR
                            (CDFILIAL, NRLANCTONF, NRSEQVENPAG, NRPARCELAPAG, QTDIASVENPAG, DTORIGVENPAG,
                            VRORIGPAG, DSCONTAPAG, DTATUAVENPAG, VRATUAPAG, IDSTATPAG, CDTPCTPAGAR,CDCLASSFINA)
                     VALUES (?,?,?,?,?,TO_DATE(?,'DD/MM/YYYY'),?,?,TO_DATE(?,'DD/MM/YYYY'),?,?,?,?)";
        $connection = $this->getEntityManager()->getConnection();
        return $connection->executeUpdate($sql,$params);
    }

    public function saveNfrelacaf($params){
        $sql = "INSERT INTO NFRELACAF
                            (CDFILIAL, CDFILLANC, NRLANCTONF, CDFILDEST,NRAUTOFORN,
                             CDPRODUTO, CDMARCA,TPROGENTAF, QTNFRELACAF, VRNFRELACAF)
                     VALUES (?,?,?,?,?,?,?,?,?,?)";
        $connection = $this->getEntityManager()->getConnection();

        return $connection->executeUpdate($sql,$params);
    }

    public function saveItemProduto($params){
        $sql = "INSERT INTO ITEMPRODUTO
                            (CDFILIAL,  CDPRODEMIS, VRUNITITEM, IDCONFORITEM, NRLANCTONF,
                            DSPRODEMIS, VRDESCITEM, CDFISOPEITEM, NRSEQITPROD, IDATUVRESTOQ,
                            VRTOTAITEM, CDSUFXCFOPPR, CDPRODUTO, QTITEMPROD, VRCONTITEM,
                            CDSITUTRIBPR, IDAVISOSITEM, VRBRUTITEM, CDFILDEST, NRAUTOFORN,
                            CDMARCA, DTPROGENTAF, CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ,
                            NRSUBLOTE,CDFILIMOVI, VRDESPERITEM, CDOPERADOR, IDITEMORIGEM, IDORIGEMPROD)
                     VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";
        $connection = $this->getEntityManager()->getConnection();
        return $connection->executeUpdate($sql,$params);
    }
    public function saveImpostoItem($params){
        $sql = "INSERT INTO TRABITPROIMPOS
                            (CDFILIMPOIT, NRLANCIMPOIT, NRSEQIMPOIT, CDIMPOSTOIT, VRCONTIMPOIT, VRREDBCIMPOIT,
                            VRBCALCIMPOIT, VRALIQIMPOIT, VRPDEDIMPOIT, VRIMPOSIT, CDFISCIMPOIT,
                            CDSTRIBIMPOIT, CDFOPERIMPOIT, CDSCFOPIMPOIT, IDERRIMPOIT, IDAVISIMPOIT,
                            NRSEQITPRO, IDVALORINFO, VR1REDBCIMPOIT, IDTRIMPSTTI, CDSTRIBITNFE, IDMODBCITEMNFE,
                            IDMODBCSTITENFE, CDTPCREDPICOITE, CDNATUBCALPCIT)
                     VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";
        $connection = $this->getEntityManager()->getConnection();
        return $connection->executeUpdate($sql,$params);
    }

    public function saveImpostoNota($params){
        $sql = "INSERT INTO TRABIMPOSNFTOT
                            (CDFILIMPTOT, NRLANCIMPTOT, CDIMPOSTOT, VRIMPOSTOT, IDERROSTOT, IDAVISOSTOT, VRBCALIMPTOT)
                     VALUES (?,?,?,?,?,?,?)";
        $connection = $this->getEntityManager()->getConnection();
        return $connection->executeUpdate($sql,$params);
    }

    public function updateIntg_notafiscal($params){
        $sql = "UPDATE INTG_NOTAFISCAL
                   SET IDIMPORTADA = 'S',
                       IDSTATUSNFE  = 'U',
                       CDFILIRECE = ?,
                       DTUTILIZAXML = SYSDATE,
                       CDFILIAL  =  ?,
                       NRLANCTONF = ?
                 WHERE NRACESSONFE = ?";
        $connection = $this->getEntityManager()->getConnection();
        return $connection->executeUpdate($sql,$params);
    }
}