IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'ATUALIZA_RESERVA_PEDIDOOL' AND
                 TYPE = 'TR' 		        AND
	              U.UID = O.UID             AND
	              U.NAME = USER)
DROP TRIGGER ATUALIZA_RESERVA_PEDIDOOL
GO

CREATE TRIGGER ATUALIZA_RESERVA_PEDIDOOL
ON ITEMPEDEXOL
AFTER UPDATE
AS
   DECLARE @V_CDFILIOPELOG            VARCHAR(4);
   DECLARE @V_CDFILIOPELOG1           VARCHAR(4);
   DECLARE @V_CDFILCENTCMP            VARCHAR(4);
   DECLARE @V_IDUTRESPEDEXOL          VARCHAR(1);
   DECLARE @V_CDPRODUTO               VARCHAR(10);
   DECLARE @V_ESTOQ_RESERVADO         FLOAT;
   DECLARE @V_ESTOQUE                 FLOAT;
   DECLARE @V_POSICAO                 FLOAT;
   DECLARE @V_IDTIPOEXOL              VARCHAR(1);

   DECLARE @V_OLD_CDFILDEST           VARCHAR(4);
   DECLARE @V_OLD_CDFILLANC           VARCHAR(4);
   DECLARE @V_OLD_NRPEDEXOL           VARCHAR(10);
   DECLARE @V_OLD_CDMARCA             VARCHAR(5);
   DECLARE @V_OLD_CDPRODUTO           VARCHAR(10);
   DECLARE @V_OLD_DTPROGENPEOL        DATETIME;
   DECLARE @V_OLD_DTPROGEMBARQ        DATETIME;
   DECLARE @V_OLD_QTPROGENPEOL        FLOAT;
   DECLARE @V_OLD_QTATENDPEDOL        FLOAT;

   DECLARE @V_ID_COMANDO              VARCHAR(1);
   DECLARE @V_NEW_CDFILDEST           VARCHAR(4);
   DECLARE @V_NEW_CDFILLANC           VARCHAR(4);
   DECLARE @V_NEW_NRPEDEXOL           VARCHAR(10);
   DECLARE @V_NEW_CDMARCA             VARCHAR(5);
   DECLARE @V_NEW_CDPRODUTO           VARCHAR(10);
   DECLARE @V_NEW_DTPROGENPEOL        DATETIME;
   DECLARE @V_NEW_QTPROGENPEOL        FLOAT;
   DECLARE @V_NEW_DTPROGEMBARQ        DATETIME;
   DECLARE @V_NEW_QTATENDPEDOL        FLOAT;
   DECLARE @V_QUANTIDADE              FLOAT;
   DECLARE @V_NEW_IDBAIXENPEOL        VARCHAR(1);

   DECLARE @V_CONTA_REG_INS NUMERIC(10);
BEGIN
   SELECT @V_CONTA_REG_INS = COUNT(*)
   FROM INSERTED;
   IF @V_CONTA_REG_INS <> 0 --SIGNIFICA QUE FOI OU INSERO DE DADOS OU ALTERAO
   BEGIN
      DECLARE C_CURSOR CURSOR FOR
         SELECT
               'U' IDCOMANDO,
                INSERTED.CDFILDEST,
                INSERTED.CDFILLANC,
                INSERTED.NRPEDEXOL,
                INSERTED.CDMARCA,
                INSERTED.CDPRODUTO,
                INSERTED.DTPROGENPEOL,
                INSERTED.QTPROGENPEOL,
                INSERTED.DTPROGEMBARQ,
                INSERTED.QTATENDPEDOL,
                INSERTED.IDBAIXENPEOL,
                DELETED.CDFILDEST,
                DELETED.CDFILLANC,
                DELETED.NRPEDEXOL,
                DELETED.CDMARCA,
                DELETED.CDPRODUTO,
                DELETED.DTPROGENPEOL,
                DELETED.QTPROGENPEOL,
                DELETED.DTPROGEMBARQ,
                DELETED.QTATENDPEDOL
           FROM
                INSERTED,
                DELETED
          WHERE
                INSERTED.CDFILDEST    =  DELETED.CDFILDEST     AND
                INSERTED.CDFILLANC    =  DELETED.CDFILLANC     AND
                INSERTED.NRPEDEXOL    =  DELETED.NRPEDEXOL     AND
                INSERTED.CDMARCA      =  DELETED.CDMARCA       AND
                INSERTED.CDPRODUTO    =  DELETED.CDPRODUTO     AND
                INSERTED.DTPROGENPEOL =  DELETED.DTPROGENPEOL  AND
                ISNULL(INSERTED.QTPROGENPEOL, 0 ) <> ISNULL(DELETED.QTPROGENPEOL, 0);

      OPEN C_CURSOR;
      FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,
                                    @V_NEW_CDFILDEST,
                                    @V_NEW_CDFILLANC,
                                    @V_NEW_NRPEDEXOL,
                                    @V_NEW_CDMARCA,
                                    @V_NEW_CDPRODUTO,
                                    @V_NEW_DTPROGENPEOL,
                                    @V_NEW_QTPROGENPEOL,
                                    @V_NEW_DTPROGEMBARQ,
                                    @V_NEW_QTATENDPEDOL,
                                    @V_NEW_IDBAIXENPEOL,
                                    @V_OLD_CDFILDEST,
                                    @V_OLD_CDFILLANC,
                                    @V_OLD_NRPEDEXOL,
                                    @V_OLD_CDMARCA,
                                    @V_OLD_CDPRODUTO,
                                    @V_OLD_DTPROGENPEOL,
                                    @V_OLD_QTPROGENPEOL,
                                    @V_OLD_DTPROGEMBARQ,
                                    @V_OLD_QTATENDPEDOL;
      WHILE (@@FETCH_STATUS = 0) BEGIN
         SELECT @V_CDFILCENTCMP = ISNULL(MAX(CDFILCENTCMP), MAX(CDFILIAL))
           FROM FILIAL
          WHERE CDFILIAL = ISNULL(@V_NEW_CDFILDEST, @V_OLD_CDFILDEST);

         SELECT @V_IDUTRESPEDEXOL = ISNULL(MAX(IDUTRESPEDEXOL), 'N')
           FROM PARASUPRI
          WHERE CDFILIAL = @V_CDFILCENTCMP;

         IF @V_IDUTRESPEDEXOL = 'S' BEGIN
            SELECT @V_CDPRODUTO = CASE MAX(R.CDPRODARVOL)
                                     WHEN MAX(P.CDPRODESTO)
                                     THEN MAX(R.CDPRODARVOL)
                                     ELSE MAX(PR.CDPRODUTO)
                                  END
              FROM RELACPRODOL R, PRODUTO P, PRODUTO PR
             WHERE P.CDPRODUTO   = R.CDPRODARVOL
               AND P.CDPRODESTO  = PR.CDPRODUTO
               AND R.CDPRARVORIG = ISNULL(@V_NEW_CDPRODUTO, @V_OLD_CDPRODUTO)
               AND R.CDMARCA     = ISNULL(@V_NEW_CDMARCA, @V_OLD_CDMARCA) ;

            SELECT @V_CDFILIOPELOG = MAX(CDFILIOPELOG), @V_IDTIPOEXOL = ISNULL(MAX(IDTIPOEXOL), 'M')
              FROM PEDIDOEXOL
             WHERE CDFILDEST    = ISNULL(@V_NEW_CDFILDEST, @V_OLD_CDFILDEST)
               AND CDFILLANC    = ISNULL(@V_NEW_CDFILLANC, @V_OLD_CDFILLANC)
               AND NRPEDEXOL    = ISNULL(@V_NEW_NRPEDEXOL, @V_OLD_NRPEDEXOL);

            IF (@V_CDFILIOPELOG IS NULL) BEGIN
               SELECT @V_CDFILIOPELOG1 = MAX(CDFILIOPELOG)
                 FROM PARAMPRODSUP
                WHERE CDFILIAL  = ISNULL(@V_NEW_CDFILDEST, @V_OLD_CDFILDEST)
                  AND CDPRODUTO = ISNULL(@V_NEW_CDFILLANC, @V_OLD_CDFILLANC);
            END
            ELSE BEGIN
               SET @V_CDFILIOPELOG1 = @V_CDFILIOPELOG;
            END;
         END;
         IF @V_ID_COMANDO = 'U' BEGIN
            IF NOT(@V_CDPRODUTO IS NULL) BEGIN
               SELECT @V_ESTOQ_RESERVADO = ISNULL(SUM(QTRESERVESTOL), 0)
                 FROM RESERVAPEDEXOL
                WHERE CDPRODUTO    =  ISNULL(@V_NEW_CDPRODUTO, @V_OLD_CDPRODUTO)
                  AND CDMARCA      =  ISNULL(@V_NEW_CDMARCA, @V_OLD_CDMARCA)
                  AND CDFILRESOL   =  @V_CDFILIOPELOG
                  AND (CDFILDEST   <> ISNULL(@V_NEW_CDFILDEST, @V_OLD_CDFILDEST)
                   OR CDFILLANC    <> ISNULL(@V_NEW_CDFILLANC, @V_OLD_CDFILLANC)
                   OR NRPEDEXOL    <> ISNULL(@V_NEW_NRPEDEXOL, @V_OLD_NRPEDEXOL)
                   OR DTPROGENPEOL <> ISNULL(@V_NEW_DTPROGENPEOL, @V_OLD_DTPROGENPEOL));

               SET @V_ESTOQUE = TEKNISA.CALC_ESTOQ_CONS(@V_CDFILIOPELOG, @V_CDPRODUTO, CONVERT(DATETIME, CONVERT(VARCHAR, GETDATE() + 1, 103),103));

               IF @V_NEW_QTPROGENPEOL <> @V_OLD_QTPROGENPEOL BEGIN
                  SET @V_QUANTIDADE =  @V_NEW_QTPROGENPEOL;
               END;
               IF @V_NEW_QTATENDPEDOL <> @V_OLD_QTATENDPEDOL BEGIN
                  SET @V_QUANTIDADE = @V_NEW_QTATENDPEDOL;
               END;

               SET @V_POSICAO = @V_ESTOQUE - (@V_ESTOQ_RESERVADO + @V_NEW_QTPROGENPEOL);
               IF @V_POSICAO >= 0 BEGIN
                  IF ((@V_QUANTIDADE > 0) AND ISNULL(ISNULL(@V_NEW_QTPROGENPEOL, @V_OLD_QTPROGENPEOL), 0) >= ISNULL(ISNULL(@V_NEW_QTATENDPEDOL, @V_OLD_QTATENDPEDOL), 0)) BEGIN
                     UPDATE RESERVAPEDEXOL
                        SET QTRESERVESTOL = @V_NEW_QTPROGENPEOL
                      WHERE CDFILDEST     = ISNULL(@V_OLD_CDFILDEST, @V_NEW_CDFILDEST)
                        AND CDFILLANC     = ISNULL(@V_OLD_CDFILLANC, @V_NEW_CDFILLANC)
                        AND NRPEDEXOL     = ISNULL(@V_OLD_NRPEDEXOL, @V_NEW_NRPEDEXOL)
                        AND CDPRODUTO     = ISNULL(@V_OLD_CDPRODUTO, @V_NEW_CDPRODUTO)
                        AND CDMARCA       = ISNULL(@V_OLD_CDMARCA, @V_NEW_CDMARCA)
                        AND DTPROGENPEOL  = ISNULL(@V_OLD_DTPROGENPEOL,@V_NEW_DTPROGENPEOL);
                     IF NOT (@@ROWCOUNT > 0) BEGIN
                        INSERT INTO RESERVAPEDEXOL (CDFILDEST, CDFILLANC, NRPEDEXOL, CDPRODUTO, CDMARCA,
                                                   DTPROGENPEOL, QTRESERVESTOL, CDFILRESOL, DTRESEMBARQ)
                        SELECT @V_NEW_CDFILDEST, @V_NEW_CDFILLANC, @V_NEW_NRPEDEXOL, @V_NEW_CDPRODUTO, @V_NEW_CDMARCA,
                              @V_NEW_DTPROGENPEOL, @V_NEW_QTPROGENPEOL, @V_CDFILIOPELOG, @V_NEW_DTPROGEMBARQ
                        WHERE NOT EXISTS (SELECT 1
                                            FROM RESERVAPEDEXOL R
                                           WHERE R.CDFILDEST    = @V_OLD_CDFILDEST
                                             AND R.CDFILLANC    = @V_OLD_CDFILLANC
                                             AND R.NRPEDEXOL    = @V_OLD_NRPEDEXOL
                                             AND R.CDPRODUTO    = @V_NEW_CDPRODUTO
                                             AND R.CDMARCA      = @V_NEW_CDMARCA
                                             AND R.DTPROGENPEOL = @V_NEW_DTPROGENPEOL);
                     END;
                  END;
               END
               ELSE BEGIN
                  DELETE FROM RESERVAPEDEXOL
                   WHERE CDFILDEST     = @V_OLD_CDFILDEST
                     AND CDFILLANC     = @V_OLD_CDFILLANC
                     AND NRPEDEXOL     = @V_OLD_NRPEDEXOL
                     AND CDPRODUTO     = @V_OLD_CDPRODUTO
                     AND CDMARCA       = @V_OLD_CDMARCA
                     AND DTPROGENPEOL  = @V_OLD_DTPROGENPEOL;
               END;
            END;
            IF ((@V_NEW_IDBAIXENPEOL = '2') OR  (@V_NEW_IDBAIXENPEOL = '3')) BEGIN
               DELETE FROM RESERVAPEDEXOL
                WHERE CDFILDEST     = @V_OLD_CDFILDEST
                  AND CDFILLANC     = @V_OLD_CDFILLANC
                  AND NRPEDEXOL     = @V_OLD_NRPEDEXOL
                  AND CDPRODUTO     = @V_OLD_CDPRODUTO
                  AND CDMARCA       = @V_OLD_CDMARCA
                  AND DTPROGENPEOL  = @V_OLD_DTPROGENPEOL;
            END;
         END;

         FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,
                                       @V_NEW_CDFILDEST,
                                       @V_NEW_CDFILLANC,
                                       @V_NEW_NRPEDEXOL,
                                       @V_NEW_CDMARCA,
                                       @V_NEW_CDPRODUTO,
                                       @V_NEW_DTPROGENPEOL,
                                       @V_NEW_QTPROGENPEOL,
                                       @V_NEW_DTPROGEMBARQ,
                                       @V_NEW_QTATENDPEDOL,
                                       @V_NEW_IDBAIXENPEOL,
                                       @V_OLD_CDFILDEST,
                                       @V_OLD_CDFILLANC,
                                       @V_OLD_NRPEDEXOL,
                                       @V_OLD_CDMARCA,
                                       @V_OLD_CDPRODUTO,
                                       @V_OLD_DTPROGENPEOL,
                                       @V_OLD_QTPROGENPEOL,
                                       @V_OLD_DTPROGEMBARQ,
                                       @V_OLD_QTATENDPEDOL;
      END;
      CLOSE      C_CURSOR;
      DEALLOCATE C_CURSOR;
   END;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'ATUALIZA_RESERVA_PEDIDOOL','5.11.000';
GO

